	MODULE GRIDS_OBS_MOD
C
C------------------------------------------------------------------------
C 	DEFINITION FOR MODEL AND FORCING GRIDS
C
C	AUTHOR	: HERVE LE BERRE	- CERFACS -
C	DATE		: 03/08/2005
C	VERSION	: 1_0_0
C------------------------------------------------------------------------
C
	USE palm_user_param
C
	IMPLICIT NONE
C
	REAL (KIND=8) , ALLOCATABLE, SAVE :: rga_RLONM1(:),rga_RLATM1(:)
	REAL (KIND=8) , ALLOCATABLE, SAVE :: rga_ALM1(:),rga_BLM1(:)
	REAL (KIND=8) , ALLOCATABLE, SAVE :: rga_PRESGRI(:)
	REAL (KIND=8) , ALLOCATABLE, SAVE :: rga_PRESINT(:)
	CHARACTER(LEN=6) , SAVE :: cg_domname
	LOGICAL , SAVE :: lg_hybrid_sigma
	LOGICAL , SAVE :: lg_periodic_lon
C	
	CONTAINS
c
	SUBROUTINE ALLOC_GRIDS_OBS
C
	ALLOCATE (rga_RLONM1(ip_lono1))
	ALLOCATE (rga_RLATM1(ip_lato1))
	IF (lg_hybrid_sigma) THEN
	    ALLOCATE (rga_ALM1(0:ip_nivm1))
	    ALLOCATE (rga_BLM1(0:ip_nivm1))
	ELSE
	    ALLOCATE (rga_presgri(ip_nivm1))
	    ALLOCATE (rga_presint(ip_nivm1))
	ENDIF
C
	END SUBROUTINE ALLOC_GRIDS_OBS
C
	SUBROUTINE DEALLOC_GRIDS
C
	DEALLOCATE (rga_RLONM1)
	DEALLOCATE (rga_RLATM1)
	IF (lg_hybrid_sigma) THEN
	    DEALLOCATE (rga_ALM1)
	    DEALLOCATE (rga_BLM1)
	ELSE
	    DEALLOCATE(rga_presgri)
	    DEALLOCATE(rga_presint)
	ENDIF
C
	END SUBROUTINE DEALLOC_GRIDS
C
	END MODULE GRIDS_OBS_MOD
