C
      SUBROUTINE H_NOV()
C
c
C
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type       : Data assimilation
C   Purpose    : Interface for data assimilation and misfit diagnostics
C   Called by  : MAIN
C
CCC
C
C Original  : M.-L. Cathala & V.-H. Peuch, CNRM/GMGEC/ERAM, 03/1999
C
C Modified  : V.-H. Peuch, CNRM/GMGEC/ERAM, 01/2001
C
CCC
C
C     MOCAGE BASED MODULES
C     PRIVATE AND PALM MODULES
      USE palmlib
      USE palm_user_param
      USE MRAT_OBS_MOD
      USE GRIDS_OBS_MOD
      USE DATDAT_MOD
C     NOVELTIS MODULES
      USE model_structure
      USE matrix_csr_structure
      USE convert_dates
      USE H_CSR
C
      IMPLICIT NONE
C
      REAL (KIND=8), ALLOCATABLE :: Hx(:)
      INTEGER :: ilon, ilat, iniv, ihx, ihx0, ib, il_lolam1, il_n_niv_i,
     $    il_n_niv_o
C
CCC PALM VARIABLES
C
      CHARACTER(LEN=PL_LNAME) :: cl_name, cl_space
      INTEGER :: il_time, il_usrtag, il_err, il_err2
      INTEGER :: il_day, il_month, il_year, il_hour, il_min, il_sec
C
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
      REAL (KIND=8) :: daynum, rl_DT0
      INTEGER ,DIMENSION(5) :: idate0
C
C daynum   : time from start (s)
C idate0   : model initial date (1)=Year (2)=Month (3)=Day (4)=Hr (5)=Min
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C
      INTEGER :: ICOUNT,IOBS,I,LOBS,IPRES,ICST,ib_i,ib_j, il_scount
      INTEGER :: il_R
      REAL (KIND=8) :: AWEIGHT,BWEIGHT
      LOGICAL :: FIRSTTIME, LASTTIME, ll_infct
      INTEGER , ALLOCATABLE :: ILOBS(:)
      INTEGER :: ib_inst, ib_nivm, ib_nivm2
C
      INTEGER, DIMENSION(ip_ninstmax) :: ila_count_slot, ila_b, ila_e 
C
      REAL (KIND=8) :: XPAPLUS,XPAMOIN
      REAL (KIND=8) :: rl_date_iasi, rl_date_secs
      REAL (KIND=8), SAVE, DIMENSION(ip_lato1,ip_lono1) :: rla_latgrid
      REAL (KIND=8), SAVE, DIMENSION(ip_lato1,ip_lono1) :: rla_longrid
      REAL (KIND=8), ALLOCATABLE, DIMENSION(:,:) :: rla_psolm1
      REAL (KIND=8), ALLOCATABLE, DIMENSION(:,:,:) :: 
     &    rla_xphfm1, rla_xpam1
      REAL (KIND=8), SAVE, DIMENSION(ip_lono1,ip_lato1,ip_nivm1,2) ::
     $    rla_presmod, rla_presmod_int
      REAL (KIND=8),
     $    DIMENSION(ip_lono1,ip_lato1,ip_nivm1,ip_nassim) ::
     $    QQQM1OBS
      REAL (KIND=8), SAVE, DIMENSION(2) :: rla_datemod
      REAL (KIND=8), ALLOCATABLE, DIMENSION(:,:,:) :: rla_avg_kernel
      REAL (KIND=8), DIMENSION(:), ALLOCATABLE :: rla_latobs
      REAL (KIND=8), DIMENSION(:), ALLOCATABLE :: rla_lonobs
      REAL (KIND=8), DIMENSION(:), ALLOCATABLE :: rla_dateobs
      REAL (KIND=8), DIMENSION(:,:), ALLOCATABLE :: rla_presobs
      REAL (KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: rla_prescol
      LOGICAL, DIMENSION(:), ALLOCATABLE :: lla_discard_obs
      REAL (KIND=8), DIMENSION(:,:), ALLOCATABLE :: rla_y
      REAL (KIND=8), ALLOCATABLE :: rla_col_weights(:,:)    
      REAL (KIND=8), ALLOCATABLE :: rla_col_cell_frac(:,:,:)
      REAL (KIND=8) :: rl_c, rl_pave, rl_ratio
      REAL (KIND=8) :: rla_var(ip_nbnivpresmax)
      INTEGER       :: il_nonzero
      INTEGER, DIMENSION(ip_nbnivpresmax) :: ila_nonzero
C
      TYPE(CSR_FORMAT) :: sl_Hres_csr, sl_Hres_tc_csr
      TYPE(MODEL_DATA),DIMENSION(ip_nassim) :: sla_mod_data
      TYPE(PALM_H_CSR), DIMENSION(:), ALLOCATABLE :: sla_H_palm
      TYPE(PALM_HAVK_CSR), DIMENSION(:), ALLOCATABLE :: sla_Havk_palm
      LOGICAL, DIMENSION(ip_nobstspmax) :: lla_discard_palm
C
      DATA FIRSTTIME/.TRUE./
      SAVE FIRSTTIME
C	
      ALLOCATE (ILOBS(ip_nobstspmax))
      il_lolam1 = ip_lono1*ip_lato1
C
      IF (ip_ninstmax_avk.lt.ip_ninstmax) ALLOCATE(sla_H_palm(1))
      IF (ip_ninstmax_avk.gt.0) ALLOCATE(sla_Havk_palm(1))
C	
C
C
CCC PALM GET THE TIME
C
      cl_space = 'one_real'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'rd_daynum'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,daynum,il_err)
c
      cl_space = 'date'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'ida_date0'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,idate0,il_err)
C
CCC PALM GET THE LOGICAL LASTTIME
C
      cl_space = 'one_logical'
      il_time = int(daynum)
      il_usrtag = PL_NO_TAG
      cl_name = 'ld_lasttime'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,LASTTIME,il_err)
C
      cl_space = 'one_logical'
      il_time = int(daynum)
      il_usrtag = PL_NO_TAG
      cl_name = 'ld_firsttime'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,FIRSTTIME,il_err)
C
      cl_space = 'one_logical'
      il_time = int(daynum)
      il_usrtag = PL_NO_TAG
      cl_name = 'ld_infct'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,ll_infct,il_err)
C
      rl_DT0 = REAL(ip_obs_slot)
C
C IF FIRSTTIME SET GEOMETRY AND RECEIVE BEGIN OF INTERVAL 
C
      IF (FIRSTTIME) THEN
          DO ib = 1,ip_lono1
            rla_latgrid(:,ib) = rga_rlatm1
          END DO
          DO ib = 1,ip_lato1
            rla_longrid(ib,:) = rga_rlonm1
          END DO
C
          rl_date_secs = idate0(4)*3600.+idate0(5)*60.+daynum
          rl_date_iasi = date_to_dayIASI(idate0(1),idate0(2),
     $        idate0(3),rl_date_secs)
          rla_datemod(1) = rl_date_iasi
C
          cl_space = 'observed_species'
          il_time = int(daynum)
          il_usrtag = PL_NO_TAG
          cl_name = 'rda_x'
C
          QQQM1OLD(:,:,:,:)=0.
          CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,QQQM1OLD,
     $         il_err)
C
          IF (lg_hybrid_sigma) THEN
C      
C* For sigma hybrid vertical coordinate get the surface pressure
C* and reconstruct the 3D pressure fields at grid cell centers
C* and at interfaces. Store them in the global array
C
              ALLOCATE (rla_psolm1(ip_lono1,ip_lato1))
              ALLOCATE (rla_xphfm1(ip_lono1,ip_lato1,ip_nivm1))
              ALLOCATE (rla_xpam1(ip_lono1,ip_lato1,ip_nivm1))
C
              rla_psolm1 = 0.
              rla_xphfm1 = 0.
              rla_xpam1 = 0.
C
              cl_space = 'ground'
              il_time = int(daynum)
              il_usrtag = PL_NO_TAG
              cl_name = 'rda_psolm1'
              CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,
     $            rla_psolm1,il_err)
C
#ifdef NIV_60
              do ilon=1,ip_lono1
                DO ilat=1,ip_lato1
                rla_xphfm1(ilon,ilat,1)=rga_ALM1(1)
     $              +rga_BLM1(1)*rla_psolm1(ilon,ilat)
                rla_xpam1(ilon,ilat,1)=0.5*rla_xphfm1(ilon,ilat,1)
                END DO
              enddo
              
              do iniv=2,ip_nivm1
                do ilon=1,ip_lono1
                  DO ilat=1,ip_lato1
                    XPAPLUS=rga_ALM1(iniv)+rga_BLM1(iniv)*
     $                  rla_psolm1(ilon,ilat)
                    rla_xphfm1(ilon,ilat,iniv)=XPAPLUS
                    XPAMOIN=rga_ALM1(iniv-1)
     $                  +rga_BLM1(iniv-1)*rla_psolm1(ilon,ilat)
                    rla_xpam1(ilon,ilat,iniv)=0.5*(XPAPLUS+XPAMOIN)
                  END DO
                enddo
              enddo
#else
              do ilon=1,ip_lono1
                DO ilat=1,ip_lato1
                  rla_xpam1(ilon,ilat,1)=
     $                EXP(ALOG(rga_ALM1(1)+rga_BLM1(1)*
     $                rla_psolm1(ilon,ilat))-1.)
                  rla_xphfm1(ilon,ilat,1)=rga_ALM1(1)
     $                +rga_BLM1(1)*rla_psolm1(ilon,ilat)
                END DO
              enddo
c
              do iniv=2,ip_nivm1
                do ilon=1,ip_lono1
                  DO ilat=1,ip_lato1
                    XPAPLUS=rga_ALM1(iniv)+rga_BLM1(iniv)*
     $                  rla_psolm1(ilon,ilat)
                    rla_xphfm1(ilon,ilat,iniv)=XPAPLUS
                    XPAMOIN=rga_ALM1(iniv-1)+rga_BLM1(iniv-1)
     $                  *rla_psolm1(ilon,ilat)
                    rla_xpam1(ilon,ilat,iniv)=EXP(
     $                  (XPAPLUS*ALOG(XPAPLUS)-XPAMOIN*ALOG(XPAMOIN))
     $                  /(XPAPLUS-XPAMOIN) - 1. )
                  END DO 
                enddo
              enddo
c
#endif
c
              rla_presmod(:,:,:,1) = rla_xpam1(:,:,:)
              rla_presmod_int(:,:,:,1) = rla_xphfm1(:,:,:)
C
              DEALLOCATE (rla_psolm1)
              DEALLOCATE (rla_xphfm1)
              DEALLOCATE (rla_xpam1)
C
          ELSE
C
C* For pure pressure vertical extend the pressures at grid cell
C* centers and at interfaces to 3D fields and store them in the
C* global array
C
              DO ilon = 1,ip_lono1
                DO ilat = 1,ip_lato1
                  DO iniv = 1,ip_nivm1
                    rla_presmod(ilon,ilat,iniv,1) =
     $                  rga_PRESGRI(iniv)
                    rla_presmod_int(ilon,ilat,iniv,1) =
     $                  rga_PRESINT(iniv)
                  END DO
                END DO
              END DO
C
          ENDIF
C
          FIRSTTIME=.FALSE.
      ENDIF
C
C RECEIVE END OF INTERVAL 
C
      rl_date_secs = idate0(4)*3600.+idate0(5)*60.+daynum+rl_DT0
      rl_date_iasi = date_to_dayIASI(idate0(1),idate0(2),
     $    idate0(3),rl_date_secs)
      rla_datemod(2) = rl_date_iasi
C
      cl_space = 'observed_species'
      il_time = int(daynum+rl_DT0)
      il_usrtag = PL_NO_TAG
      cl_name = 'rda_x'
c
      QQQM1obs(:,:,:,:)=0.
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,QQQM1obs,il_err)
C
      IF (lg_hybrid_sigma) THEN
C      
C* For sigma hybrid vertical coordinate get the surface pressure
C* and reconstruct the 3D pressure fields at grid cell centers
C* and at interfaces. Store them in the global array
C
          ALLOCATE (rla_psolm1(ip_lono1,ip_lato1))
          ALLOCATE (rla_xphfm1(ip_lono1,ip_lato1,ip_nivm1))
          ALLOCATE (rla_xpam1(ip_lono1,ip_lato1,ip_nivm1))
C
          rla_psolm1 = 0.
          rla_xphfm1 = 0.
          rla_xpam1 = 0.
          cl_space = 'ground'
          il_time = int(daynum+rl_DT0)
          il_usrtag = PL_NO_TAG
          cl_name = 'rda_psolm1'
          CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,rla_psolm1,
     &        il_err)
C
#ifdef NIV_60
          do ilon=1,ip_lono1
            DO ilat=1,ip_lato1
              rla_xphfm1(ilon,ilat,1)=rga_ALM1(1)+rga_BLM1(1)*
     $            rla_psolm1(ilon,ilat)
              rla_xpam1(ilon,ilat,1)=0.5*rla_xphfm1(ilon,ilat,1)
            END DO
          enddo
      
          do iniv=2,ip_nivm1
            do ilon=1,ip_lono1
              DO ilat=1,ip_lato1
                XPAPLUS=rga_ALM1(iniv)+rga_BLM1(iniv)*
     $              rla_psolm1(ilon,ilat)
                rla_xphfm1(ilon,ilat,iniv)=XPAPLUS
                XPAMOIN=rga_ALM1(iniv-1)+rga_BLM1(iniv-1)*
     $              rla_psolm1(ilon,ilat)
                rla_xpam1(ilon,ilat,iniv)=0.5*(XPAPLUS+XPAMOIN)
              END DO
            enddo
          enddo
      
#else
          do ilon=1,ip_lono1
            DO ilat=1,ip_lato1
              rla_xpam1(ilon,ilat,1)=
     $          EXP(ALOG(rga_ALM1(1)+rga_BLM1(1)*
     $            rla_psolm1(ilon,ilat))-1.)
              rla_xphfm1(ilon,ilat,1)=rga_ALM1(1)+rga_BLM1(1)*
     $          rla_psolm1(ilon,ilat)
            END DO
          enddo
C
          do iniv=2,ip_nivm1
            do ilon=1,ip_lono1
              DO ilat=1,ip_lato1
                XPAPLUS=rga_ALM1(iniv)+rga_BLM1(iniv)*
     $              rla_psolm1(ilon,ilat)
                rla_xphfm1(ilon,ilat,iniv)=XPAPLUS
                XPAMOIN=rga_ALM1(iniv-1)+rga_BLM1(iniv-1)*
     $              rla_psolm1(ilon,ilat)
                rla_xpam1(ilon,ilat,iniv)=EXP(
     $              (XPAPLUS*ALOG(XPAPLUS)-XPAMOIN*ALOG(XPAMOIN))
     $              /(XPAPLUS-XPAMOIN) - 1. )
              END DO
            enddo
          enddo
C
#endif
C
          rla_presmod(:,:,:,2) = rla_xpam1(:,:,:)
          rla_presmod_int(:,:,:,2) = rla_xphfm1(:,:,:)
C
          DEALLOCATE (rla_psolm1)
          DEALLOCATE (rla_xphfm1)
          DEALLOCATE (rla_xpam1)
C
      ELSE
C
C* For pure pressure vertical extend the pressures at grid cell
C* centers and at interfaces to 3D fields and store them in the
C* global array
C
          DO ilon = 1,ip_lono1
            DO ilat = 1,ip_lato1
              DO iniv = 1,ip_nivm1
                rla_presmod(ilon,ilat,iniv,2) =
     $              rga_PRESGRI(iniv)
                rla_presmod_int(ilon,ilat,iniv,2) =
     $              rga_PRESINT(iniv)
              END DO
            END DO
          END DO
C
      ENDIF
C
C
C INITIALISATION OF Hx
C
CAP We make the assumption that nbconstmax = ip_nassim !
C
      ALLOCATE(Hx(ip_nobstspmax*ip_nbnivpresmax*ip_nassim))
      Hx(:)=0.
      rga_misfit=0.
C
C Working for every assimilated tracer
C
      iHx0=0
      ila_count_slot(:)=0
      ila_b(:)=ig_nobs
      ila_e(:)=0
C
      DO i = 1, ip_nassim
C
C
C SELECT OBSERVATIONS IN CURRENT TIMESTEP
C
CAP
CAP Should insert a tracer selection for when 
CAP observing more than 1 species
CAP
        icount=0
        DO iobs=1,ig_nobs
          IF (icount.GT.ip_nobstspmax) THEN
              WRITE(*,*) '+ TOO MANY OBS. FOR CURRENT TIMESTEP: ABORT!'
              CALL PALM_Abort(il_err)
          ENDIF
          IF ((INT(daynum).LE.iga_secobs(iobs)).AND.
     +        (INT(daynum+rl_DT0).GT.iga_secobs(iobs))) THEN                 
              icount=icount+1
              ILOBS(icount)=iobs
              ila_count_slot(iga_inst(iobs)) =
     $            ila_count_slot(iga_inst(iobs))+1
              IF (ila_b(iga_inst(iobs)) .gt. icount)
     $            ila_b(iga_inst(iobs))=icount
              IF (ila_e(iga_inst(iobs)) .lt. icount)
     $            ila_e(iga_inst(iobs))=icount
          ENDIF
        END DO
C
C PREPARE MODEL DATA IN NOVELTIS STRUCTURES
C
        IF (icount.EQ.0) THEN
            WRITE(PL_OUT,*) '+* NO OBS. FOR CURRENT TIMESTEP'
            WRITE(PL_OUT,*) '+* FOR SPECIES ',tranam1obs(i)
            WRITE(*,*) '+* NO OBS. FOR CURRENT TIMESTEP'
            WRITE(*,*) '+* FOR SPECIES ',tranam1obs(i)
        ELSE
            ALLOCATE(sla_mod_data(i)%lat(ip_lato1,ip_lono1))
            ALLOCATE(sla_mod_data(i)%lon(ip_lato1,ip_lono1))
            ALLOCATE(sla_mod_data(i)%
     $          pres(ip_lono1,ip_lato1,ip_nivm1,2))
            ALLOCATE(sla_mod_data(i)%traceur
     $          (ip_lono1,ip_lato1,ip_nivm1,2))
            sla_mod_data(i)%nlat = ip_lato1
            sla_mod_data(i)%nlon = ip_lono1
            sla_mod_data(i)%nlev = ip_nivm1
            DO ib=1,2
              sla_mod_data(i)%pres(:,:,:,ib)=
     $            rla_presmod(:,:,:,ib)
            END DO
            sla_mod_data(i)%traceur(:,:,:,1) = QQQM1OLD(:,:,:,i)
            sla_mod_data(i)%traceur(:,:,:,2) = QQQM1obs(:,:,:,i)
        ENDIF
C
C LOOP OVER THE INSTRUMENTS
C
        DO ib_inst = 1,ig_ninst
C
          il_scount = ila_count_slot(ib_inst)
C
          IF (il_scount.NE.0) THEN
C
C PREPARING OBSERVATION INPUT FOR THE INTERVAL
C
              il_n_niv_i = 1
              il_n_niv_o = 1
              DO iobs=ila_b(ib_inst),ila_e(ib_inst)
                lobs=ILOBS(iobs)
C
                IF (iga_npreslev(lobs).gt.il_n_niv_o)
     $              il_n_niv_o = iga_npreslev(lobs)
                IF (iga_nobslev(lobs).gt.il_n_niv_i)
     $              il_n_niv_i = iga_nobslev(lobs)
                IF (lga_int_qty(ib_inst)) THEN
                    IF (iga_iq_vertlev(lobs).gt.il_n_niv_i)
     $                  il_n_niv_i = iga_iq_vertlev(lobs)
                ENDIF
              END DO
              IF (ip_tc_as_prof.eq.1.and.
     $            lga_tot_col(ib_inst)) il_n_niv_o = ip_nivm1
C
              ALLOCATE(rla_latobs(il_scount))
              ALLOCATE(rla_lonobs(il_scount))
              ALLOCATE(rla_dateobs(il_scount))
              IF (lga_tot_col(ib_inst)) THEN
                  ALLOCATE(rla_prescol(2,il_n_niv_i,il_scount))
                  rla_prescol=0.                
              ELSE
                  ALLOCATE(rla_presobs(il_n_niv_i,il_scount))
                  rla_presobs=0.
              ENDIF
C
              DO iobs=1,il_scount
                lobs=ILOBS(ila_b(ib_inst)-1+iobs)
C
                rla_latobs(iobs) = rga_obslat(lobs)
                rla_lonobs(iobs) = rga_obslon(lobs)
                IF (lga_tot_col(ib_inst)) THEN
                    DO ib=1,iga_nobslev(lobs)
                      rla_prescol(1,ib,iobs)=rga_preslev(lobs,ib,1)
                      rla_prescol(2,ib,iobs)=rga_preslev(lobs,ib,2)
                    END DO
                ELSE
                    DO ib=1,max(iga_nobslev(lobs),
     $                  iga_iq_vertlev(lobs))
                      rla_presobs(ib,iobs)=rga_preslev(lobs,ib,1)
                    END DO
                ENDIF                  
                rl_date_secs = idate0(4)*3600.+idate0(5)*60.+
     $              iga_secobs(lobs)
                rla_dateobs(iobs) =
     $              date_to_dayIASI(idate0(1),idate0(2),idate0(3),
     $              rl_date_secs)
              END DO
C
C ALLOCATE RESULTS and PREPARE EXTRA INPUT
C
C
              ALLOCATE(lla_discard_obs(il_scount))
C
              IF(lga_tot_col(ib_inst)) THEN
C 
                  IF (ip_tc_as_prof.eq.0) THEN
                      CALL observ_operator_tc (
     $                    ip_lato1,
     $                    ip_lono1,
     $                    ip_nivm1,
     $                    2,
     $                    rla_latgrid,
     $                    rla_longrid,
     $                    rla_presmod,
     $                    rla_presmod_int,
     $                    rla_datemod,
     $                    il_scount,
     $                    il_n_niv_i,
     $                    rla_latobs,
     $                    rla_lonobs,
     $                    rla_dateobs,
     $                    rla_prescol,
     $                    .true.,
     $                    sl_Hres_csr,
     $                    lla_discard_obs)
C
                  ELSE
                      ALLOCATE(rla_col_weights(ip_nivm1,il_scount))
                      ALLOCATE(rla_col_cell_frac
     $                    (il_n_niv_i,ip_nivm1,il_scount))
C
                      CALL observ_operator_tc2 (
     $                    ip_lato1,
     $                    ip_lono1,
     $                    ip_nivm1,
     $                    2,
     $                    rla_latgrid,
     $                    rla_longrid,
     $                    rla_presmod,
     $                    rla_presmod_int,
     $                    rla_datemod,
     $                    il_scount,
     $                    il_n_niv_i,
     $                    rla_latobs,
     $                    rla_lonobs,
     $                    rla_dateobs,
     $                    rla_prescol,
     $                    .true.,
     $                    sl_Hres_csr,
     $                    rla_col_weights,   
     $                    rla_col_cell_frac, 
     $                    lla_discard_obs)
                  ENDIF
C
              ELSE
                  IF (lga_avg_kernel(ib_inst)) THEN
                          allocate(rla_avg_kernel(il_n_niv_o,
     $                        il_n_niv_i,ip_nobsperinst_avk_slot))
                          rla_avg_kernel(:,:,:)=0.
                          DO iobs=1,il_scount
                            lobs=ILOBS(ila_b(ib_inst)-1+iobs)
                            rla_avg_kernel(:,:,iobs)=
     $                          rga_avk(iga_avk_idx(lobs),1:il_n_niv_o,
     $                          1:il_n_niv_i,i)
                          END DO
                  ELSE
                      allocate(rla_avg_kernel(1,1,1))
                      rla_avg_kernel(:,:,:)=0.
                  ENDIF
C
C CREATE H MATRIX     
C
                  IF (MINVAL(rla_presobs,rla_presobs.gt.0.) 
     $                .lt. MINVAL(rla_presmod).and.ip_iprint.gt.0) THEN
                      WRITE(PL_OUT,*) 'OBSERVATION OVER THE ROOF !!!!!!'
                      WRITE(PL_OUT,*) 'date ',rla_dateobs
                      WRITE(PL_OUT,*) 'min presobs ',
     $                    minval(rla_presobs,rla_presobs.gt.0.)
                      WRITE(PL_OUT,*) 'min presmod ',minval(rla_presmod)
                      WRITE(*,*) 'OBSERVATION OVER THE ROOF !!!!!!!'
                      WRITE(*,*) 'date ',rla_dateobs
                      WRITE(*,*) 'min presobs ',
     $                    minval(rla_presobs,rla_presobs.gt.0.)
                      WRITE(*,*) 'min presmod ',minval(rla_presmod)
                  END IF
                  IF (MAXVAL(rla_presobs,rla_presobs.gt.0.) 
     $                .gt. MAXVAL(rla_presmod).and.ip_iprint.gt.0) THEN
                      WRITE(PL_OUT,*)
     $                    'OBSERVATION UNDER THE SURFACE !!!!!!!'
                      WRITE(PL_OUT,*) 'date ',rla_dateobs
                      WRITE(PL_OUT,*) 'max presobs ',
     $                    maxval(rla_presobs,rla_presobs.gt.0.)
                      WRITE(PL_OUT,*) 'max presmod ',maxval(rla_presmod)
                      WRITE(*,*) 'OBSERVATION UNDER THE SURFACE !!!!!!!'
                      WRITE(*,*) 'date ',rla_dateobs
                      WRITE(*,*) 'max presobs ',
     $                    maxval(rla_presobs,rla_presobs.gt.0.)
                      WRITE(*,*) 'max presmod ',maxval(rla_presmod)
                  END IF
C
                  CALL observ_operator (
     $                ip_lato1,
     $                ip_lono1,
     $                ip_nivm1,
     $                2,
     $                rla_latgrid,
     $                rla_longrid,
     $                rla_presmod,
     $                rla_datemod,
     $                il_scount,
     $                il_n_niv_i,
     $                il_n_niv_o,
     $                rla_latobs,
     $                rla_lonobs,
     $                rla_dateobs,
     $                rla_presobs,
     $                rla_avg_kernel,
     $                lga_avg_kernel(ib_inst),
     $                .true.,
     $                sl_Hres_csr,
     $                lla_discard_obs)
C
                  DEALLOCATE(rla_avg_kernel)
              END IF
C
              DEALLOCATE(rla_latobs)
              DEALLOCATE(rla_lonobs)
              DEALLOCATE(rla_dateobs)
              IF (lga_tot_col(ib_inst)) THEN
                  DEALLOCATE(rla_prescol)
              ELSE
                  DEALLOCATE(rla_presobs)
              ENDIF
C
C PREPARE RESULT VECTOR
C
              ALLOCATE(rla_y(il_n_niv_o,il_scount))
              rla_y(:,:)=0.
C
C MULTIPLY OBS OPERATOR
C
              CALL multiply_observ_operator (
     $            sl_Hres_csr,
     $            sla_mod_data(i),
     $            2,
     $            lla_discard_obs,
     $            il_scount,
     $            il_n_niv_o,
     $            rla_y)
C
C STORE H IN PALM COMPLIANT VECTORS AND SEND IT + DISCARD
C
C
C PALM PUT OF H ONE FOR SPECIES (the tag make the difference)
C
              IF (ll_infct) THEN
C
                  IF (lga_avg_kernel(ib_inst)) THEN
                      sla_Havk_palm(1)%NPRF = sl_Hres_csr%NPRF
                      sla_Havk_palm(1)%ncol = sl_Hres_csr%ncol
                      sla_Havk_palm(1)%nrow = sl_Hres_csr%nrow
                      sla_Havk_palm(1)%nmax = sl_Hres_csr%nmax
                      sla_Havk_palm(1)%i(1:sl_Hres_csr%nrow+1,
     $                    1:sl_Hres_csr%NPRF) = sl_Hres_csr%i(:,:)
                      sla_Havk_palm(1)%j(1:sl_Hres_csr%nmax,
     $                    1:sl_Hres_csr%NPRF) = sl_Hres_csr%j(:,:)
                      sla_Havk_palm(1)%H(1:sl_Hres_csr%nmax,
     $                    1:sl_Hres_csr%NPRF) = sl_Hres_csr%H(:,:)
C
                      cl_space = 'CSR_HAVK'
                      il_time = int(daynum)
                      il_usrtag = ib_inst
                      cl_name = 'Havk_csr'
                      CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,
     $                    sla_Havk_palm(1),il_err)
C
                      IF (il_err.ne.0) THEN
                          CALL PALM_Error_explain(il_err, il_err2)
                      ENDIF
C
C PALM PUT OF lla_discard ONE FOR SPECIES (the tag make the difference)
C
                      lla_discard_palm(1:il_scount) =
     $                    lla_discard_obs(1:il_scount)
C
                      cl_space = 'CSR_HAVK_discard'
                      il_time = int(daynum)
                      il_usrtag = ib_inst
                      cl_name = 'Havk_discard'
                      CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,
     $                    lla_discard_palm,il_err)
C
                      IF (il_err.ne.0) THEN
                          CALL PALM_Error_explain(il_err, il_err2)
                      ENDIF
C
                  ELSE
C
                      sla_H_palm(1)%NPRF = sl_Hres_csr%NPRF
                      sla_H_palm(1)%ncol = sl_Hres_csr%ncol
                      sla_H_palm(1)%nrow = sl_Hres_csr%nrow
                      sla_H_palm(1)%nmax = sl_Hres_csr%nmax
                      sla_H_palm(1)%i(1:sl_Hres_csr%nrow+1,
     $                    1:sl_Hres_csr%NPRF) = sl_Hres_csr%i(:,:)
                      sla_H_palm(1)%j(1:sl_Hres_csr%nmax,
     $                    1:sl_Hres_csr%NPRF) = sl_Hres_csr%j(:,:)
                      sla_H_palm(1)%H(1:sl_Hres_csr%nmax,
     $                    1:sl_Hres_csr%NPRF) = sl_Hres_csr%H(:,:)
C
                      cl_space = 'CSR_H'
                      il_time = int(daynum)
                      il_usrtag = ib_inst
                      cl_name = 'H_csr'
                      CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,
     $                    sla_H_palm(1),il_err)
C
                      IF (il_err.ne.0) THEN
                          CALL PALM_Error_explain(il_err, il_err2)
                      ENDIF
C
C PALM PUT OF lla_discard ONE FOR SPECIES (the tag make the difference)
C
                      lla_discard_palm(1:il_scount) =
     $                    lla_discard_obs(1:il_scount)
C
                      cl_space = 'CSR_H_discard'
                      il_time = int(daynum)
                      il_usrtag = ib_inst
                      cl_name = 'H_discard'
                      CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,
     $                    lla_discard_palm,il_err)
C
                      IF (il_err.ne.0) THEN
                          CALL PALM_Error_explain(il_err, il_err2)
                      ENDIF
C
                  ENDIF
C
              ENDIF
C
              DEALLOCATE(lla_discard_obs)
C
C STORE MISFIT Yo-H(x) IN PALM COMPLIANT VECTORS
C
              IF (lga_tot_col(ib_inst).and.ip_tc_as_prof.eq.1) THEN
                  DO iobs = 1,il_scount
                    il_R=ila_b(ib_inst)-1+iobs
                    lobs=ILOBS(ila_b(ib_inst)-1+iobs)
                    rla_var(:)=0.
                    DO iniv = 1,iga_nobslev(lobs)
                      rla_var(iniv)=
     $                    rga_invR(il_R,iniv,iniv,1)
                    END DO
                    rga_invR(il_R,:,:,1)=0.
                    ila_nonzero(:) = 0
                    DO iniv = 1,iga_nobslev(lobs)
                      rl_c=0.
                      rl_pave=0.
                      il_nonzero=0
                      DO ib_nivm = 1,iga_npreslev(lobs)
                        rl_c=rl_c+
     $                      rla_col_cell_frac(iniv,ib_nivm,iobs)*
     $                      rla_col_weights(ib_nivm,iobs)*
     $                      rla_y(ib_nivm,iobs)
                        rl_pave=rl_pave+
     $                      rla_col_cell_frac(iniv,ib_nivm,iobs)*
     $                      rla_y(ib_nivm,iobs)
                        IF (rla_col_cell_frac(iniv,ib_nivm,iobs)
     $                      .gt.1e-10) THEN
                            il_nonzero=il_nonzero+1 
                            ila_nonzero(ib_nivm)=1
                        ENDIF
                      END DO
                      rl_pave=rl_pave/il_nonzero
                      rga_Hx(lobs,iniv,1)=rl_c
                      iHx=iHx0+(iniv-1)*ip_nobstspmax
     $                    +ila_b(ib_inst)-1+iobs
                      Hx(iHx)=rga_val(lobs,iniv,1)-rl_c
                      rl_ratio=Hx(iHx)/rl_c
                      DO ib_nivm = 1,iga_npreslev(lobs) 
                        iHx=iHx0+(ib_nivm-1)*ip_nobstspmax+
     $                      ila_b(ib_inst)-1+iobs
                        rga_misfit(iHx)=rga_misfit(iHx)+
     $                      rla_y(ib_nivm,iobs)*
     $                      rla_col_cell_frac(iniv,ib_nivm,iobs)*
     $                      rl_ratio
                      END DO
C
C** Obs. err. variance comes from column variance by square
C   proportionality
C
                      DO ib_nivm = 1,iga_npreslev(lobs) 
                        IF (rla_col_cell_frac(iniv,ib_nivm,iobs)
     $                      .gt.1e-10) THEN
                            IF (0.eq.1) THEN
                                rga_invR(il_R,ib_nivm,ib_nivm,1)=
     $                              rga_invR(il_R,ib_nivm,ib_nivm,1)+
     $                              rla_var(iniv)*(rl_c/
     $                              rl_pave)**2.
                            ELSE
                                rga_invR(il_R,ib_nivm,ib_nivm,1)=
     $                              rga_invR(il_R,ib_nivm,ib_nivm,1)+
     $                              rla_var(iniv)*(rl_c/
     $                              (rla_y(ib_nivm,iobs)*
     $                              rla_col_cell_frac(iniv,ib_nivm,
     $                              iobs))
     $                              )**2.
                            ENDIF
C
C** Take into account full correlation between levels
C
CAP                            DO ib_nivm2=ib_nivm,iga_npreslev(lobs)
CAP                              IF (rla_col_cell_frac(iniv,ib_nivm2,iobs)
CAP     $                            .gt.1e-10) THEN
CAP                                  rga_invR(lobs,ib_nivm,ib_nivm2,1)=
CAP     $                                rga_invR(lobs,ib_nivm,ib_nivm2,1)
CAP     $                                +1.
CAP                                  rga_invR(lobs,ib_nivm2,ib_nivm,1)=
CAP     $                                rga_invR(lobs,ib_nivm2,ib_nivm,1)
CAP     $                                +1.
CAP                              ENDIF
CAP                            END DO
C
                        ENDIF
                      END DO
C
                    END DO
                    iga_zerolev(lobs)=iga_npreslev(lobs)
     $                  -SUM(ila_nonzero)
                  END DO
              ELSE
                  DO iobs = 1,il_scount
                    lobs=ILOBS(ila_b(ib_inst)-1+iobs)
                    DO iniv = 1,iga_nobslev(lobs)
                      rga_Hx(lobs,iniv,1)=rla_y(iniv,iobs)
                      iHx=iHx0+(iniv-1)*ip_nobstspmax+
     $                    ila_b(ib_inst)-1+iobs
                      Hx(iHx)=rga_val(lobs,iniv,1)-rla_y(iniv,iobs)
                      rga_misfit(iHx)=Hx(iHx)
                    END DO
                  END DO
              END IF
C
              DEALLOCATE(rla_y)
              IF (lga_tot_col(ib_inst).and.ip_tc_as_prof.eq.1) THEN
                  DEALLOCATE(rla_col_cell_frac)
                  DEALLOCATE(rla_col_weights)
              END IF
C
          ELSE
C
              WRITE(PL_OUT,*) '+* NO OBS. FOR CURRENT TIMESTEP'
              WRITE(PL_OUT,*) '+* FOR INSTRUMENT ',
     $            trim(cga_inst(ib_inst))
              WRITE(*,*) '+* NO OBS. FOR CURRENT TIMESTEP'
              WRITE(*,*) '+* FOR INSTRUMENT ',
     $            trim(cga_inst(ib_inst))
C
          ENDIF
C
        END DO
C
C MOVE THE Hx POINTER TO THE NEXT SPECIES
C
        iHx0 = iHx0 + ip_nobstspmax*ip_nbnivpresmax
C
C DEALLOCATE NOVELTIS MODEL STRUCTURES
C
        IF (icount .gt. 0) THEN
C
              DEALLOCATE(sla_mod_data(i)%lat)
              DEALLOCATE(sla_mod_data(i)%lon)
              DEALLOCATE(sla_mod_data(i)%pres)
              DEALLOCATE(sla_mod_data(i)%traceur)
              NULLIFY(sla_mod_data(i)%lat)
              NULLIFY(sla_mod_data(i)%lon)
              NULLIFY(sla_mod_data(i)%pres)
              NULLIFY(sla_mod_data(i)%traceur)
        END IF
C
      END DO
C
C
C PALM PUT OF Hx (all the species are concatenated)
C
CAP
CAP  WHEN working with more than one species we'll have to
CAP  handle a counter for each kind of obs and an overall counter
CAP
      IF (icount. gt. 0) THEN
          cl_space = 'vectobs'
          il_time = int(daynum)
          il_usrtag = PL_NO_TAG
          cl_name = 'rda_misfit'
          CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,Hx,il_err)
C
          IF (ll_infct) THEN
              cl_space = 'matcovobs'
              il_time = int(daynum)
              il_usrtag = PL_NO_TAG
              cl_name = 'rda_invR'
              CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,rga_invR,
     $        il_err)
          ENDIF
C
      ENDIF
C
C DEALLOCATE USELESS VECTORS
C
      DEALLOCATE(Hx)
C
      IF (.NOT.LASTTIME) THEN
C
C SHIFT THE SECOND TIME VECTOR TO FIRST PLACE
C
          rla_datemod(1) = rla_datemod(2)
C
          rla_presmod(:,:,:,1) = rla_presmod(:,:,:,2)
C
          QQQM1OLD = QQQM1obs
C
      ENDIF
C
      DEALLOCATE (ILOBS)
C
      IF (ip_ninstmax_avk.lt.ip_ninstmax) DEALLOCATE(sla_H_palm)
      IF (ip_ninstmax_avk.gt.0) DEALLOCATE(sla_Havk_palm)
C
      RETURN
      END
C
CCC
C
