C
      SUBROUTINE WRTDAT
c
      USE palmlib
C
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type       : Observations
C   Purpose    : Write output diagnostic data file on observations locations
C   Called by  : MADONA
C
CCC
C
C Original  : M.-L. Cathala & V.-H. Peuch, CNRM/GMGEC/ERAM, 03/1999
C
C Modified  : V.-H. Peuch, CNRM/GMGEC/ERAM, 01/2001
C
CCC
C
      USE palm_user_param
      USE GRIDS_OBS_MOD
      USE DATDAT_MOD
      USE MRAT_OBS_MOD
C
      IMPLICIT NONE
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
      REAL (KIND=8) :: daynum, rl_DT0
      INTEGER , DIMENSION (5) :: idate0
      LOGICAL :: LEND, ll_infct, ll_first
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C
      INTEGER :: flag
C
      REAL (KIND=8), SAVE :: MISSTP(ip_nobstspmax*ip_nbnivpresmax*
     $   ip_nbconstmax)
      REAL rl_perc_mf
C
      INTEGER :: ILOBS(ip_nobstspmax)
      INTEGER, ALLOCATABLE :: ila_ct(:)
      INTEGER :: icount, lobs, ipres, imis, il_unit
      INTEGER :: il_rstart,il_rend
      INTEGER :: il_fstart,il_fend
      INTEGER :: I,IOBS,INIV,J,K,NBDAY,NBHOUR
      INTEGER :: il_tshold, il_obscount
      INTEGER :: il_loader_verb
      CHARACTER(LEN=32) :: clf1
      CHARACTER(LEN=4),DIMENSION(-1:3) :: cla_rejected
      INTEGER :: ib_inst, il_scount
      INTEGER, DIMENSION(ip_ninstmax) :: ila_count_slot, ila_b 
      INTEGER :: il_idx, il_looplevels
      LOGICAL :: ll_omffile
      LOGICAL :: ll_dry, ll_fct, ll_ana
C
CCC NetCDF related variables
C
      INCLUDE 'netcdf.inc'
      CHARACTER(LEN=32) :: cln1
      CHARACTER(LEN=48) :: cldat, cltori
C     
      INTEGER,SAVE :: il_ncfile, il_dins, il_dobs, il_dlev, il_dslot
      INTEGER,SAVE :: il_dc68, il_dc3, il_one
      INTEGER,SAVE :: il_fins, il_fobs, il_flev, il_fslot
      INTEGER,SAVE :: il_nc_inst_descr, il_nc_inst_species
      INTEGER,SAVE :: il_nc_obs_nr
      INTEGER,SAVE :: il_nc_latitude, il_nc_longitude, il_nc_nlevels 
      INTEGER,SAVE :: il_nc_p_bound_1,il_nc_p_bound_2
      INTEGER,SAVE :: il_nc_observation, il_nc_dry_run 
      INTEGER,SAVE :: il_nc_forecast, il_nc_analysis
      INTEGER,SAVE :: il_nc_tshold
C      INTEGER,SAVE :: il_nc_omd, il_nc_omd_pc
C      INTEGER,SAVE :: il_nc_omf, il_nc_omf_pc
C      INTEGER,SAVE :: il_nc_oma, il_nc_oma_pc
      INTEGER :: ila_ncdims(4), ila_ncstart(4), ila_nccount(4)
C
      CHARACTER(LEN=3), DIMENSION(ip_ninstmax) :: cga_spec
      REAL, DIMENSION(ip_nobstspmax) :: dla_lat
      REAL, DIMENSION(ip_nobstspmax) :: dla_lon
      REAL,DIMENSION(ip_nobstspmax,ip_nbnivpresmax) ::
     $    dla_val
C, dla_diff, dla_dpc
      REAL,DIMENSION(ip_nobstspmax,ip_nbnivpresmax) ::
     $    dla_p1, dla_p2
      REAL(KIND=4), DIMENSION(ip_nobstspmax) :: rla_lat
      REAL(KIND=4), DIMENSION(ip_nobstspmax) :: rla_lon
      REAL(KIND=4), DIMENSION(ip_nbnivpresmax)
     $    :: rla_v
      REAL(KIND=4), DIMENSION(:), ALLOCATABLE :: rla_dim
      REAL(KIND=4) :: rl_daynum
      REAL(KIND=4) :: rl_tshold
      REAL(KIND=4) :: rl_missing
      INTEGER :: il_missing
      INTEGER :: il_nslot
C
      INTEGER, DIMENSION(ip_nobstspmax) :: ila_nlev     
      REAL(KIND=4), DIMENSION(ip_nobstspmax) :: rla_nlev
C
      LOGICAL, DIMENSION(ip_nbfenet*(ip_fenetre/ip_obs_slot),4), SAVE ::
     $    lla_ncdone = .FALSE.
C
CCC PALM VARIABLES
C
      CHARACTER(LEN=PL_LNAME) cl_name, cl_space
      INTEGER il_time, il_usrtag, il_err, il_err2
      INTEGER il_day, il_month, il_year, il_hour, il_min, il_sec
C
CCC 0. PALM GET OF INPUTS
C
      rl_DT0 = real(ip_obs_slot)
C
      cl_space = 'one_integer'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'verbosity'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,il_loader_verb,
     $    il_err)
c
      cl_space = 'one_real'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'rd_daynum'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,daynum,il_err)
c
      cl_space = 'date'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'ida_date0'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,idate0,il_err)
c
      cl_space = 'one_integer'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'il_rstart'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,il_rstart,il_err)
C
      cl_space = 'one_integer'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'il_rend'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,il_rend,il_err)
C
      cl_space = 'one_integer'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'il_fstart'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,il_fstart,il_err)
C
      cl_space = 'one_integer'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'il_fend'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,il_fend,il_err)
C
      cl_space = 'one_integer'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'id_flag'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,flag,il_err)
C
      cl_space = 'one_logical'
      il_time = int(daynum)
      il_usrtag = PL_NO_TAG
      cl_name = 'ld_infct'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,ll_infct,il_err)
C
      cl_space = 'one_integer'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'threshold'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,il_tshold,il_err)
C
      IF (flag .lt. 0) flag = -flag
C
CCC SELECT BETWEEN FCST, FCST AFTER NO OBS, ANALYSIS and DRY RUN
C
      ll_dry = (ip_omd.eq.1
     $    .and.il_rstart.eq.0.and.il_fstart.eq.0)
C
      ll_ana = (int(daynum).ge.il_rstart.and.int(daynum).lt.il_fstart
     $    .and.ip_oma.eq.1)
C
      ll_fct = (int(daynum).ge.il_fstart.and.int(daynum).lt.il_fend
     $    .and.ip_omf.eq.1)
C
      IF (ip_omd.eq.0) lla_ncdone(:,1)=.TRUE.
      IF (ip_omf.eq.0) lla_ncdone(:,2)=.TRUE.
      IF (ip_oma.eq.0) lla_ncdone(:,3)=.TRUE.
C
      il_nslot=(INT(daynum)/ip_obs_slot)+1
C
C SELECT OBSERVATIONS IN CURRENT TIMESTEP
C
      icount=0
      il_obscount = 0
      ila_count_slot(:)=0
      ila_b(:)=ig_nobs
      DO iobs=1,ig_nobs
        IF ((int(daynum).LE.iga_secobs(iobs)).AND.
     +      (int(daynum+rl_DT0).GT.iga_secobs(iobs))) THEN
            icount=icount+1
            ILOBS(icount)=iobs
            il_obscount=il_obscount+iga_npreslev(iobs)-iga_zerolev(iobs)
            ila_count_slot(iga_inst(iobs)) =
     $          ila_count_slot(iga_inst(iobs))+1
            IF (ila_b(iga_inst(iobs)) .gt. icount)
     $          ila_b(iga_inst(iobs))=icount
        ENDIF
      END DO
C
C PALM GET MISFIT AT CURRENT STEP
c
      IF (icount. gt. 0) THEN 
          cl_space = 'vectobs'
          il_time = int(daynum)
          il_usrtag = PL_NO_TAG
          cl_name = 'rda_misfit'
          CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,MISSTP,
     $        il_err)
C
C REJECT OBSERVATION WITH TOO HIGH A MISFIT
C
          IF (il_tshold .ne. 0) THEN
              DO i=1,icount
                iobs=ILOBS(i)
                ll_first=.true.
                DO j=1,iga_nobslev(iobs)
                  DO k=1,iga_nbconst(iobs,j)
                    imis=(j-1)*ip_nobstspmax+i
                    IF (ABS(MISSTP(imis)).gt.ABS(rga_Hx(iobs,j,k))*
     $                  REAL(il_tshold)/100.) THEN
                        IF (lga_tot_col(iga_inst(iobs))) THEN
                            IF (ll_first) THEN
                                IF (ANY(iga_tshold(iobs,:,k).eq.1)) THEN
                                    iga_tshold(iobs,:,k) = 2
                                ELSE
                                    iga_tshold(iobs,:,k) = 0
                                ENDIF
                                il_obscount=il_obscount-
     $                              iga_npreslev(iobs)+iga_zerolev(iobs)
                                ll_first=.false.
                            ENDIF
                        ELSE
                            IF (iga_tshold(iobs,j,k) .eq. 1) THEN
                                iga_tshold(iobs,j,k) = 2
                            ELSE
                                iga_tshold(iobs,j,k) = 0
                            ENDIF
                           il_obscount=il_obscount-1
                        ENDIF
                        IF (il_loader_verb .GT. 1) THEN
                            IF (ABS(rga_Hx(iobs,j,k)).gt.1e-18) THEN
                                rl_perc_mf=ABS(MISSTP(imis)*100./
     $                              rga_Hx(iobs,j,k))
                            ELSE
                                rl_perc_mf = 999.
                            ENDIF
                            WRITE(*,'(A25,I3)')
     $                          ' + REJECTED level number ',j
                            WRITE(*,'(A21,I4)')
     $                          '   of profile number ', iobs
                            WRITE(*,'(A7,F8.2)')
     $                          '   Lat ',rga_obslat(iobs)
                            WRITE(*,'(A7,F8.2)')
     $                          '   Lon ',rga_obslon(iobs)
                            WRITE(*,'(A8,F8.0)')
     $                          '  Pres ',rga_preslev(iobs,j,k)
                            WRITE(*,*) '  from DATA set ',
     $                          trim(cga_inst(iga_inst(iobs)))
                            WRITE(*,*) '  x_b ',rga_Hx(iobs,j,k)
                            WRITE(*,*) '  y_o ',rga_val(iobs,j,k)
                            WRITE(*,*) '  % misfit',rl_perc_mf
C
                            WRITE(PL_OUT,'(A25,I3)')
     $                          ' + REJECTED level number ',j
                            WRITE(PL_OUT,'(A21,I4)')
     $                          '   of profile number ', iobs
                            WRITE(PL_OUT,'(A7,F8.2)')
     $                          '   Lat ',rga_obslat(iobs)
                            WRITE(PL_OUT,'(A7,F8.2)')
     $                          '   Lon ',rga_obslon(iobs)
                            WRITE(PL_OUT,'(A8,F8.0)')
     $                          '  Pres ',rga_preslev(iobs,j,k)
                            WRITE(PL_OUT,*) '  from DATA set ',
     $                          trim(cga_inst(iga_inst(iobs)))
                            WRITE(PL_OUT,*) '  x_b ',rga_Hx(iobs,j,k)
                            WRITE(PL_OUT,*) '  y_o ',rga_val(iobs,j,k)
                            WRITE(PL_OUT,*) '  % misfit',rl_perc_mf
C
                        END IF
                    ELSE
                        IF (lga_tot_col(iga_inst(iobs))) THEN
                            IF (ll_first) THEN
                                IF (ANY(iga_tshold(iobs,:,k).eq.0)) THEN
                                    iga_tshold(iobs,:,k) = -1
                                ELSE
                                    iga_tshold(iobs,:,k) = 1
                                ENDIF
                            ENDIF
                        ELSE
                            IF (iga_tshold(iobs,j,k) .eq. 0) THEN
                                iga_tshold(iobs,j,k) = -1
                            ELSE
                                iga_tshold(iobs,j,k) = 1
                            ENDIF
                        ENDIF
                    END IF
                  END DO
                END DO
              END DO
          ELSE
              iga_tshold(:,:,:) = 1
          ENDIF
C      
      ENDIF
C
      IF (ll_infct) THEN
C
          WRITE(PL_OUT,'(A44,I5,A5,I5,A3,I6)')
     $        '++  NUMBER OF SELECTED OBSERVATIONS BETWEEN ',
     $        int(daynum),' AND ',int(daynum+rl_DT0),
     +        ' : ',il_obscount
C
          IF (ig_ninst .gt. 1) THEN
              ALLOCATE(ila_ct(ig_ninst))
              ila_ct(:) = 0
              DO i = 1,icount
                iobs = ILOBS(i)
                DO j=1,iga_npreslev(iobs)
                  DO k=1,iga_nbconst(iobs,j)
                    IF (ABS(iga_tshold(iobs,j,k)) .EQ. 1 )
     $                  ila_ct(iga_inst(iobs))=ila_ct(iga_inst(iobs))+1
                  END DO
                END DO
              END DO
              DO i = 1,ig_ninst
                WRITE(PL_OUT,'(A20,A39,A3,I6)') ' +  FOR INSTRUMENT: ',
     $              cga_inst(i)(1:39),' : ',ila_ct(i)
              END DO
              DEALLOCATE(ila_ct)
          END IF
C
          cl_space = 'one_integer'
          il_time = int(daynum)
          il_usrtag = PL_NO_TAG
          cl_name = 'id_icount'
          CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,il_obscount,
     $        il_err)
      ENDIF

C
CCC 2. WRITE DIAGNOSTICS
C
CCC OmF and OmA cannot be output together : switch by filename
C
      IF (ll_fct) THEN
          WRITE(clf1,
     +    fmt="('HDOMF+',I4.4,I2.2,I2.2,I2.2,'+',I4.4,I2.2,I2.2,I2.2)")
     +    idate0(1),idate0(2),idate0(3),idate0(4),
     +    idate0(1),idate0(2),idate0(3),idate0(4)+ip_assimsize/3600
          il_unit = 86
          il_idx = 2
      END IF
C
      IF (ll_ana) THEN
          WRITE(clf1,
     +    fmt="('HDOMA+',I4.4,I2.2,I2.2,I2.2,'+',I4.4,I2.2,I2.2,I2.2)")
     +    idate0(1),idate0(2),idate0(3),idate0(4),
     +    idate0(1),idate0(2),idate0(3),idate0(4)+ip_assimsize/3600
          il_unit = 87
          il_idx = 3
      END IF
C
CCC OmD and OmF can be true together (1st window)
C
 99   IF (ll_dry.and..not.ll_fct) THEN
          WRITE(clf1,
     +    fmt="('HDOMD+',I4.4,I2.2,I2.2,I2.2,'+',I4.4,I2.2,I2.2,I2.2)")
     +    idate0(1),idate0(2),idate0(3),idate0(4),
     +    idate0(1),idate0(2),idate0(3),idate0(4)+ip_assimsize/3600
          il_unit = 85
          il_idx = 1
      END IF

C
CCC OUTPUT
C
      IF (ll_fct.OR.ll_ana.OR.ll_dry) THEN
          IF (.not.lla_ncdone(1,il_idx)) THEN
              INQUIRE(FILE=clf1, EXIST=ll_omffile)
C
              OPEN(unit=il_unit,file=clf1,form='formatted',
     $            position='append')
              IF (.NOT.ll_omffile) THEN         
                  WRITE(*,'(A25,A32)')'++ CREATING DIAG. FILE : ',clf1
                  WRITE(il_unit,*) ig_nobs,ig_ninst
                  DO i=1,ig_ninst
                    WRITE(il_unit,101) cga_inst(i)
                  END DO
              ENDIF
          ENDIF
C
          IF (ip_iprint .eq. 1)
     $        WRITE(*,'(A27,A32)') '++ WRITING IN DIAG. FILE : ',
     $        clf1
C
CCC THE FLAGS in HDOM*
C
C   R = Rejected:      The misfit is over the threshold
C   D = Discarded:     The misfit is over the threshold, but it 
C                      wasn't during the previous run
C   A = Assimilated:   The misfit is under the threshold
C   I = Included:      The misfit is under the threshold, but it 
C                      wasn't during the previous run
C   U = Uninitialized: The observation has never been treated 
C                      (symptom of an error)
C
C
          cla_rejected(0)='R'
          cla_rejected(2)='D'
          cla_rejected(1)='A'
          cla_rejected(-1)='I'
          cla_rejected(3)='U'
C
          DO i=1,icount
            iobs=ILOBS(i)
            WRITE(il_unit,102)
     +          iga_dateobs(iobs,1),iga_dateobs(iobs,2),
     +          iga_dateobs(iobs,3),iga_dateobs(iobs,4),
     +          iga_dateobs(iobs,5),
     +          cga_str_id(iobs),iga_int_id(iobs),
     +          rga_obslat(iobs),rga_obslon(iobs),
     +          iga_nobslev(iobs)
            il_looplevels = iga_nobslev(iobs)
            IF (lga_int_qty(iga_inst(iobs))) il_looplevels=1
            DO j=1,il_looplevels
              IF (lga_tot_col(iga_inst(iobs))) THEN
                  WRITE(il_unit,106) rga_preslev(iobs,j,1),
     +                rga_preslev(iobs,j,2),iga_nbconst(iobs,j)
              ELSE
                  WRITE(il_unit,103)
     +                rga_preslev(iobs,j,1),iga_nbconst(iobs,j)
              END IF
              DO k=1,iga_nbconst(iobs,j)
                imis=(j-1)*ip_nobstspmax+i
                IF (ABS(rga_Hx(iobs,j,k)).gt.1e-18) THEN
                    rl_perc_mf=ABS(MISSTP(imis)*100./rga_Hx(iobs,j,k))
                ELSE
                    rl_perc_mf = 999.
                ENDIF
                WRITE(il_unit,105)
     +              cga_constname(iobs,j,k),
     +              rga_Hx(iobs,j,k),
     +              rga_val(iobs,j,k),
     +              MISSTP(imis),
     +              rl_perc_mf,
     +              '%',TRIM(cla_rejected(iga_tshold(iobs,j,k)))
              ENDDO
            ENDDO
          ENDDO
          lla_ncdone(il_nslot,il_idx) = .TRUE.
      ENDIF
C
CCC NetCDF output
C
      WRITE(cln1,
     +    fmt="('HSTAT+',I4.4,I2.2,I2.2,I2.2,'+',
     +    I4.4,I2.2,I2.2,I2.2,'.nc')")
     +    idate0(1),idate0(2),idate0(3),idate0(4),
     +    idate0(1),idate0(2),idate0(3),idate0(4)+ip_assimsize/3600
      
C
C** Missing values
C
      rl_missing = -9999.
      il_missing = -9999
C 
      IF (ll_fct.OR.ll_ana.OR.ll_dry) THEN
          IF (.not.lla_ncdone(1,4)) THEN         
              WRITE(*,'(A25,A32)')'++ CREATING DIAG. FILE : ',cln1
              il_err = NF_CREATE(cln1, NF_CLOBBER, il_ncfile)
C
C** DEFINE DIMENSIONS
C
              il_err = NF_DEF_DIM(il_ncfile, 'time', NF_UNLIMITED,
     $            il_dslot)
              il_err = NF_DEF_DIM(il_ncfile, 'lev',  ip_nbnivpresmax,
     $            il_dlev)
              il_err = NF_DEF_DIM(il_ncfile, 'obs',  ip_nobstspmax,
     $            il_dobs)
              il_err = NF_DEF_DIM(il_ncfile, 'ins',  ig_ninst,
     $            il_dins)
              il_err = NF_DEF_DIM(il_ncfile, 'c68',  68, il_dc68)
              il_err = NF_DEF_DIM(il_ncfile, 'c3',   3, il_dc3)
              il_err = NF_DEF_DIM(il_ncfile, 'one',  1, il_one)
C
C** DEFINE DIMENSION VARIABLES
C
              ila_ncdims(1) = il_dins
              il_err = NF_DEF_VAR(il_ncfile, 'ins', NF_REAL, 1, 
     $            ila_ncdims, il_fins)
C
              ila_ncdims(1) = il_dobs
              il_err = NF_DEF_VAR(il_ncfile, 'obs', NF_REAL, 1, 
     $            ila_ncdims, il_fobs)
C
              ila_ncdims(1) = il_dlev
              il_err = NF_DEF_VAR(il_ncfile, 'lev', NF_REAL, 1, 
     $            ila_ncdims, il_flev)
C
              ila_ncdims(1) = il_dslot
              il_err = NF_DEF_VAR(il_ncfile, 'time', NF_REAL, 1, 
     $            ila_ncdims, il_fslot)
C
C** DEFINE ATTRIBUTES
C
              il_err = NF_PUT_ATT_TEXT(il_ncfile, NF_GLOBAL, 
     $            'Conventions', 6, 'CF-1.0')
              il_err = NF_PUT_ATT_TEXT(il_ncfile, NF_GLOBAL, 
     $            'institution', 16, 'CNRM and CERFACS')
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_fslot, 
     $            'standard_name', 9, 'Time axis')
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_fslot,'axis',
     $            1, 't')
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_fobs, 
     $            'standard_name', 11, 'Observation')
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_fins, 
     $            'standard_name', 10, 'Instrument')
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_flev, 
     $            'standard_name', 5, 'Level')
              WRITE(cldat,fmt=
     $            '(''seconds since '',
     $            I4.4,"-",I2.2,"-",I2.2," ",I2.2,":",I2.2,":00")')
     $            idate0(1),idate0(2),idate0(3),idate0(4),idate0(5)
              WRITE(cltori,fmt=
     $            '(I4.4,"-",I2.2,"-",I2.2," ",I2.2,":",I2.2,":00")')
     $            idate0(1),idate0(2),idate0(3),idate0(4),idate0(5)
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_fslot,'units',
     $            LEN_TRIM(cldat), cldat)
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_fslot,
     $            'time_origin',LEN_TRIM(cltori), cltori)
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_fslot,'calendar', 
     $            6,'noleap')
C
C** DEFINE VARIABLES AND ATTRIBUTES
C
C*  INSTRUMENT DESCRIPTION (2D in c68,ins)      
C
              ila_ncdims(1) = il_dc68
              ila_ncdims(2) = il_dins
C
              il_ERR = NF_DEF_VAR(il_ncfile,'instr_descr',
     $            NF_CHAR,2,ila_ncdims,il_nc_inst_descr)
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_inst_descr,
     $            'long_name', 22, 'instrument description')
C
C*  MEASURED SPECIES (2D in c3,ins)      
C
              ila_ncdims(1) = il_dc3
              ila_ncdims(2) = il_dins
C
              il_ERR = NF_DEF_VAR(il_ncfile,'instr_species',
     $            NF_CHAR,2,ila_ncdims,il_nc_inst_species)
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_inst_species, 
     $            'long_name', 34, 'species measured by the instrument')
C
C*  NUMBER OF LOCATIONS IN SLOT (2D in ins,slot)
C
              ila_ncdims(1) = il_dins
              ila_ncdims(2) = il_dslot
              il_err = NF_DEF_VAR(il_ncfile, 'obs_nr', 
     $            NF_INT,2, ila_ncdims, il_nc_obs_nr)
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_obs_nr, 
     $            'long_name', 26, 'nr of observations in slot')
C
C*  NUMBER OF LOCATIONS IN SLOT (2D in ins,slot)
C
              ila_ncdims(1) = il_one
              il_err = NF_DEF_VAR(il_ncfile, 'rejection', 
     $            NF_REAL,1, ila_ncdims, il_nc_tshold)
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_tshold, 
     $            'long_name', 23, 'Rejection threshold (%)')
C
C*  LATITUDES (3D in ins,obs,slot)      
C
              ila_ncdims(1) = il_dins
              ila_ncdims(2) = il_dobs
              ila_ncdims(3) = il_dslot
C
              il_err = NF_DEF_VAR(il_ncfile, 'latitude', 
     $            NF_REAL,3, ila_ncdims, il_nc_latitude)
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_latitude, 
     $            'standard_name', 8, 'latitude')
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_latitude, 
     $            'long_name', 27, 'Latitude of the observation')
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_latitude, 
     $            'units', 13, 'degrees_north')
              il_err = NF_PUT_ATT_REAL(il_ncfile, il_nc_latitude,
     $                      'missing_value', NF_REAL, 1,
     $                      rl_missing)
C
C*  LONGITUDES (3D in ins,obs,slot)      
C
              ila_ncdims(1) = il_dins
              ila_ncdims(2) = il_dobs
              ila_ncdims(3) = il_dslot
C
              il_err = NF_DEF_VAR(il_ncfile, 'longitude', 
     $            NF_REAL,3, ila_ncdims, il_nc_longitude)
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_longitude, 
     $            'standard_name', 9, 'longitude')
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_longitude, 
     $            'long_name', 28, 'Longitude of the observation')
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_longitude, 
     $            'units', 12, 'degrees_east')
              il_err = NF_PUT_ATT_REAL(il_ncfile, il_nc_longitude,
     $                      'missing_value', NF_REAL, 1,
     $                      rl_missing)
C
C*  NUMBER OF LEVELS (3D in ins,obs,slot)      
C
              ila_ncdims(1) = il_dins
              ila_ncdims(2) = il_dobs
              ila_ncdims(3) = il_dslot
C
              il_err = NF_DEF_VAR(il_ncfile, 'nlevels', 
     $            NF_INT,3, ila_ncdims, il_nc_nlevels)
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_nlevels, 
     $            'standard_name', 12, 'nr_of_levels')
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_nlevels, 
     $            'long_name', 25, 'number of vertical levels')
              il_err = NF_PUT_ATT_INT(il_ncfile, il_nc_nlevels,
     $                      'missing_value', NF_INT, 1,
     $                      il_missing)
C
C*  LOWER PRESSURE BOUND (4D in ins,obs,lev,slot)      
C
              ila_ncdims(1) = il_dins
              ila_ncdims(2) = il_dobs
              ila_ncdims(3) = il_dlev
              ila_ncdims(4) = il_dslot
C
              il_err = NF_DEF_VAR(il_ncfile, 'p_bound_1', 
     $            NF_REAL,4, ila_ncdims, il_nc_p_bound_1)
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_p_bound_1, 
     $            'long_name', 29, 'lower bound of vertical slice')
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_p_bound_1, 
     $            'units', 6, 'Pascal')
              il_err = NF_PUT_ATT_REAL(il_ncfile, il_nc_p_bound_1,
     $                      'missing_value', NF_REAL, 1,
     $                      rl_missing)
C
C*  UPPER PRESSURE BOUND (4D in ins,obs,lev,slot)      
C
              ila_ncdims(1) = il_dins
              ila_ncdims(2) = il_dobs
              ila_ncdims(3) = il_dlev
              ila_ncdims(4) = il_dslot
C
              il_err = NF_DEF_VAR(il_ncfile, 'p_bound_2', 
     $            NF_REAL,4, ila_ncdims, il_nc_p_bound_2)
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_p_bound_2, 
     $            'long_name', 29, 'upper bound of vertical slice')
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_p_bound_2, 
     $           'units', 6, 'Pascal')
              il_err = NF_PUT_ATT_REAL(il_ncfile, il_nc_p_bound_2,
     $                      'missing_value', NF_REAL, 1,
     $                      rl_missing)
C
C*  Observation (4D in ins,obs,lev,slot)      
C
              ila_ncdims(1) = il_dins
              ila_ncdims(2) = il_dobs
              ila_ncdims(3) = il_dlev
              ila_ncdims(4) = il_dslot
C
              il_err = NF_DEF_VAR(il_ncfile, 'Observation', 
     $            NF_REAL,4, ila_ncdims, il_nc_observation)
              il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_observation, 
     $            'long_name', 14, 'measured value')
              il_err = NF_PUT_ATT_REAL(il_ncfile, il_nc_observation,
     $                      'missing_value', NF_REAL, 1,
     $                      rl_missing)
C
C*  Dry run field (4D in ins,obs,lev,slot)      
C
              IF (ip_omd .eq. 1) THEN
                  ila_ncdims(1) = il_dins
                  ila_ncdims(2) = il_dobs
                  ila_ncdims(3) = il_dlev
                  ila_ncdims(4) = il_dslot
C
                  il_err = NF_DEF_VAR(il_ncfile, 'Dry_run', 
     $                NF_REAL,4, ila_ncdims, il_nc_dry_run)
                  il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_dry_run, 
     $                'long_name', 13, 'dry run field')
                  il_err = NF_PUT_ATT_REAL(il_ncfile, il_nc_dry_run,
     $                'missing_value', NF_REAL, 1,
     $                rl_missing)
              END IF
C
C*  Forecast field (4D in ins,obs,lev,slot)      
C
              IF (ip_omf .eq. 1) THEN
                  ila_ncdims(1) = il_dins
                  ila_ncdims(2) = il_dobs
                  ila_ncdims(3) = il_dlev
                  ila_ncdims(4) = il_dslot
C
                  il_err = NF_DEF_VAR(il_ncfile, 'Forecast', 
     $                NF_REAL,4, ila_ncdims, il_nc_forecast)
                  il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_forecast, 
     $                'long_name', 14, 'forecast field')
                  il_err = NF_PUT_ATT_REAL(il_ncfile, il_nc_forecast,
     $                'missing_value', NF_REAL, 1,
     $                rl_missing)
              END IF
C
C*  Analysis field (4D in ins,obs,lev,slot)      
C
              IF (ip_oma .eq. 1) THEN
                  ila_ncdims(1) = il_dins
                  ila_ncdims(2) = il_dobs
                  ila_ncdims(3) = il_dlev
                  ila_ncdims(4) = il_dslot
C
                  il_err = NF_DEF_VAR(il_ncfile, 'Analysis', 
     $                NF_REAL,4, ila_ncdims, il_nc_analysis)
                  il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_analysis, 
     $                'long_name', 14, 'analysis field')
                  il_err = NF_PUT_ATT_REAL(il_ncfile, il_nc_analysis,
     $                'missing_value', NF_REAL, 1,
     $                rl_missing)
              END IF
C
C*  Observation minus dry run (4D in ins,obs,lev,slot)      
C
C              IF (ip_omd .eq. 1) THEN
C                  ila_ncdims(1) = il_dins
C                  ila_ncdims(2) = il_dobs
C                  ila_ncdims(3) = il_dlev
C                  ila_ncdims(4) = il_dslot
C
C                  il_err = NF_DEF_VAR(il_ncfile, 'OmD', 
C     $                NF_REAL,4, ila_ncdims, il_nc_omd)
C                  il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_omd, 
C     $                'long_name', 25, 'observation minus dry run')
C                  il_err = NF_PUT_ATT_REAL(il_ncfile, il_nc_omd,
C     $                'missing_value', NF_REAL, 1,
C     $                rl_missing)
C
C                  il_err = NF_DEF_VAR(il_ncfile, 'OmD_pc', 
C     $                NF_REAL,4, ila_ncdims, il_nc_omd_pc)
C                  il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_omd_pc, 
C     $                'long_name', 27, 'observation minus dry run %')
C                  il_err = NF_PUT_ATT_REAL(il_ncfile, il_nc_omd_pc,
C     $                'missing_value', NF_REAL, 1,
C     $                rl_missing)
C                  
C              END IF
C
C*  Observation minus forecast (4D in ins,obs,lev,slot)      
C
C              IF (ip_omf .eq. 1) THEN
C                  ila_ncdims(1) = il_dins
C                  ila_ncdims(2) = il_dobs
C                  ila_ncdims(3) = il_dlev
C                  ila_ncdims(4) = il_dslot
C
C                  il_err = NF_DEF_VAR(il_ncfile, 'OmF', 
C     $                NF_REAL,4, ila_ncdims, il_nc_omf)
C                  il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_omf, 
C     $                'long_name', 26, 'observation minus forecast')
C                  il_err = NF_PUT_ATT_REAL(il_ncfile, il_nc_omf,
C     $                'missing_value', NF_REAL, 1,
C     $                rl_missing)
C
C                  il_err = NF_DEF_VAR(il_ncfile, 'OmF_pc', 
C     $                NF_REAL,4, ila_ncdims, il_nc_omf_pc)
C                  il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_omf_pc, 
C     $                'long_name', 28, 'observation minus forecast %')
C                  il_err = NF_PUT_ATT_REAL(il_ncfile, il_nc_omf_pc,
C     $                'missing_value', NF_REAL, 1,
C     $                rl_missing)
C              END IF
C
C*  Observation minus analysis (4D in ins,obs,lev,slot)      
C
C              IF (ip_oma .eq. 1) THEN
C                  ila_ncdims(1) = il_dins
C                  ila_ncdims(2) = il_dobs
C                  ila_ncdims(3) = il_dlev
C                  ila_ncdims(4) = il_dslot
C
C                  il_err = NF_DEF_VAR(il_ncfile, 'OmA', 
C     $                NF_REAL,4, ila_ncdims, il_nc_oma)
C                  il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_oma, 
C     $                'long_name', 26, 'observation minus analysis')
C                  il_err = NF_PUT_ATT_REAL(il_ncfile, il_nc_oma,
C     $                'missing_value', NF_REAL, 1,
C     $                rl_missing)
C
C                  il_err = NF_DEF_VAR(il_ncfile, 'OmA_pc', 
C     $                NF_REAL,4, ila_ncdims, il_nc_oma_pc)
C                  il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_oma_pc, 
C     $                'long_name', 28, 'observation minus analysis %')
C                  il_err = NF_PUT_ATT_REAL(il_ncfile, il_nc_oma_pc,
C     $                'missing_value', NF_REAL, 1,
C     $                rl_missing)
C              END IF
C
C** END OF DEFINE MODE
C
              il_err= NF_ENDDEF(il_ncfile)
C
C output of instrument descriptions
C 
              il_err = NF_PUT_VAR_TEXT(il_ncfile,il_nc_inst_descr,
     $            cga_inst)
C
C output of instrument species
C 
              cga_spec(:)=cga_assim_spe(1)
C
              il_err = NF_PUT_VAR_TEXT(il_ncfile,il_nc_inst_species,
     $            cga_spec)
C
              ALLOCATE(rla_dim(ig_ninst))
              rla_dim=REAL((/(i,i=1,ig_ninst)/))
              il_ERR = NF_PUT_VAR_REAL(il_ncfile,il_fins,rla_dim)
              DEALLOCATE(rla_dim)
C
              ALLOCATE(rla_dim(ip_nobstspmax))
              rla_dim=REAL((/(i,i=1,ip_nobstspmax)/))
              il_ERR = NF_PUT_VAR_REAL(il_ncfile,il_fobs,rla_dim)
              DEALLOCATE(rla_dim)
C
              ALLOCATE(rla_dim(ip_nbnivpresmax))
              rla_dim=REAL((/(i,i=1,ip_nbnivpresmax)/))
              il_ERR = NF_PUT_VAR_REAL(il_ncfile,il_flev,rla_dim)
              DEALLOCATE(rla_dim)
C
C output of rejection threshold
C
              rl_tshold = REAL(il_tshold)
              il_ERR = NF_PUT_VAR_REAL(il_ncfile,il_nc_tshold,rl_tshold)
C
          ELSE
              il_err = NF_OPEN(cln1, NF_WRITE, il_ncfile)              
          ENDIF
C
C output of slot related values (independent of levels)
C
          IF (.not. lla_ncdone(il_nslot,4)) THEN
C
C output of time reference
C
              ila_ncstart(1) = il_nslot
              ila_nccount(1) = 1
              rl_daynum=REAL(daynum)
              il_err = NF_PUT_VARA_REAL(il_ncfile,il_fslot,ila_ncstart,
     $            ila_nccount,rl_daynum)
C
C for each instrument
C
              DO ib_inst = 1,ig_ninst
C
                il_scount = ila_count_slot(ib_inst)
C
C output the number of locations in the slot 
C
                ila_ncstart(1:2)=(/ib_inst,il_nslot/)
                il_ERR = NF_PUT_VAR1_INT(il_ncfile,il_nc_obs_nr,
     $              ila_ncstart,il_scount)
C
C output the coordinates and the number of levels for each location
C
                IF (il_scount.NE.0) THEN
C
                    ila_nlev(:)=il_missing
C
                    DO iobs = 1, il_scount
                      lobs=ILOBS(ila_b(ib_inst)-1+iobs)
C
                      dla_lat(iobs)=rga_obslat(lobs)
                      dla_lon(iobs)=rga_obslon(lobs)
                      ila_nlev(iobs)=iga_nobslev(lobs)
C
                      DO iniv = 1,iga_nobslev(lobs)
C                    
                        dla_val(iobs,iniv)=rga_val(lobs,iniv,1)
                        dla_p1(iobs,iniv)=rga_preslev(lobs,iniv,1)
                        dla_p2(iobs,iniv)=rga_preslev(lobs,iniv,1)
C
                      END DO
C
                    END DO
C
                    rla_lat(:)=rl_missing
                    rla_lat(1:il_scount)=REAL(dla_lat(1:il_scount))
                    rla_lon(:)=rl_missing
                    rla_lon(1:il_scount)=REAL(dla_lon(1:il_scount))
                    ila_ncstart(1:3)=(/ib_inst,1,il_nslot/)
                    ila_nccount(1:3)=(/1,ip_nobstspmax,1/)
                    il_ERR = NF_PUT_VARA_REAL(il_ncfile,il_nc_latitude,
     $                  ila_ncstart,ila_nccount,rla_lat)
C
                    il_ERR = NF_PUT_VARA_REAL(il_ncfile,il_nc_longitude,
     $                  ila_ncstart,ila_nccount,rla_lon)
C
                    il_ERR = NF_PUT_VARA_INT(il_ncfile,il_nc_nlevels,
     $                  ila_ncstart,ila_nccount,ila_nlev)
C
C output the pressure bounds
C
                    DO iobs = 1, il_scount
                      ila_ncstart(1:4)=(/ib_inst,iobs,1,il_nslot/)
                      ila_nccount(1:4)=(/1,1,ip_nbnivpresmax,1/)
                      rla_v(:)=rl_missing
                      rla_v(1:ila_nlev(iobs))=
     $                    REAL(dla_p1(iobs,1:ila_nlev(iobs)))
                      il_ERR = NF_PUT_VARA_REAL(il_ncfile,
     $                    il_nc_p_bound_1,ila_ncstart,ila_nccount,
     $                    rla_v)
C
                      rla_v(:)=rl_missing
                      rla_v(1:ila_nlev(iobs))=
     $                    REAL(dla_p2(iobs,1:ila_nlev(iobs)))
                      il_ERR = NF_PUT_VARA_REAL(il_ncfile,
     $                    il_nc_p_bound_2,ila_ncstart,ila_nccount,
     $                    rla_v)
                    END DO
C
                    DO iobs = il_scount+1, ip_nobstspmax
                      ila_ncstart(1:4)=(/ib_inst,iobs,1,il_nslot/)
                      ila_nccount(1:4)=(/1,1,ip_nbnivpresmax,1/)
                      rla_v(:)=rl_missing
                      il_ERR = NF_PUT_VARA_REAL(il_ncfile,
     $                    il_nc_p_bound_1,ila_ncstart,ila_nccount,
     $                    rla_v)
C
                      il_ERR = NF_PUT_VARA_REAL(il_ncfile,
     $                    il_nc_p_bound_2,ila_ncstart,ila_nccount,
     $                    rla_v)
                    END DO                    
C
C output the observation values
C
                    DO iobs = 1, il_scount
                      ila_ncstart(1:4)=(/ib_inst,iobs,1,il_nslot/)
                      ila_nccount(1:4)=(/1,1,ip_nbnivpresmax,1/)
                      rla_v(:)=rl_missing
                      rla_v(1:ila_nlev(iobs))=
     $                    REAL(dla_val(iobs,1:ila_nlev(iobs)))
                      il_ERR = NF_PUT_VARA_REAL(il_ncfile,
     $                    il_nc_observation,ila_ncstart,ila_nccount,
     $                    rla_v)
                    END DO
C                    
                   DO iobs = il_scount+1, ip_nobstspmax
                      ila_ncstart(1:4)=(/ib_inst,iobs,1,il_nslot/)
                      ila_nccount(1:4)=(/1,1,ip_nbnivpresmax,1/)
                      rla_v(:)=rl_missing
                      il_ERR = NF_PUT_VARA_REAL(il_ncfile,
     $                    il_nc_observation,ila_ncstart,ila_nccount,
     $                    rla_v)
                    END DO
C
                ELSE
C
                    ila_nlev(:)=il_missing
                    rla_lat(:)=rl_missing
                    rla_lon(:)=rl_missing
                    ila_ncstart(1:3)=(/ib_inst,1,il_nslot/)
                    ila_nccount(1:3)=(/1,ip_nobstspmax,1/)
                    il_ERR = NF_PUT_VARA_REAL(il_ncfile,il_nc_latitude,
     $                  ila_ncstart,ila_nccount,rla_lat)
C
                    il_ERR = NF_PUT_VARA_REAL(il_ncfile,il_nc_longitude,
     $                  ila_ncstart,ila_nccount,rla_lon)
C
                    il_ERR = NF_PUT_VARA_INT(il_ncfile,il_nc_nlevels,
     $                  ila_ncstart,ila_nccount,ila_nlev)
C                    
                    rla_v(:)=rl_missing
C
                    DO iobs = 1, ip_nobstspmax
                      ila_ncstart(1:4)=(/ib_inst,iobs,1,il_nslot/)
                      ila_nccount(1:4)=(/1,1,ip_nbnivpresmax,1/)
C
                      il_ERR = NF_PUT_VARA_REAL(il_ncfile,
     $                    il_nc_p_bound_1,ila_ncstart,ila_nccount,
     $                    rla_v)
C
                      il_ERR = NF_PUT_VARA_REAL(il_ncfile,
     $                    il_nc_p_bound_2,ila_ncstart,ila_nccount,
     $                    rla_v)
C
                      il_ERR = NF_PUT_VARA_REAL(il_ncfile,
     $                    il_nc_observation,ila_ncstart,ila_nccount,
     $                    rla_v)
                    END DO                    
C
                END IF
C
              END DO
C
              lla_ncdone(il_nslot,4) = .TRUE.
C
          END IF
C
C** OUTPUT FORECAST VALUES
C
C
          IF (ll_fct.or.ll_ana.or.ll_dry) THEN
              DO ib_inst = 1,ig_ninst
C
                il_scount = ila_count_slot(ib_inst)
                IF (il_scount.NE.0) THEN
                    DO iobs = 1, il_scount
                      lobs=ILOBS(ila_b(ib_inst)-1+iobs)
C
                      DO iniv = 1,iga_nobslev(lobs)
C
                        dla_val(iobs,iniv)=rga_Hx(lobs,iniv,1)
C                        dla_diff(iobs,iniv)=rga_val(lobs,iniv,1)-
C     $                      rga_Hx(lobs,iniv,1)
C                        IF (ABS(rga_Hx(lobs,iniv,1)).gt.1e-18) THEN
C                            dla_dpc(iobs,iniv)=ABS(dla_diff(iobs,iniv))
C     $                          *100./dla_val(iobs,iniv)
C                        ELSE
C                            dla_dpc(iobs,iniv)= 999.
C                        ENDIF
C
                      END DO
                    END DO
                END IF
C
C** OUTPUT DRY RUN VALUES
C
                IF (ll_dry) THEN
                    DO iobs = 1, il_scount
                      ila_ncstart(1:4)=(/ib_inst,iobs,1,il_nslot/)
                      ila_nccount(1:4)=(/1,1,ip_nbnivpresmax,1/)
C
                      rla_v(:) = rl_missing
C
                      lobs=ILOBS(ila_b(ib_inst)-1+iobs)
                      ila_nlev(iobs) = iga_nobslev(lobs)
C
                      rla_v(1:ila_nlev(iobs))=
     $                    REAL(dla_val(iobs,1:ila_nlev(iobs)))
                      il_ERR = NF_PUT_VARA_REAL(il_ncfile,
     $                    il_nc_dry_run,ila_ncstart,ila_nccount,
     $                    rla_v)
C
C                      rla_v(1:ila_nlev(iobs))=
C     $                    REAL(dla_diff(iobs,1:ila_nlev(iobs)))
C                      il_ERR = NF_PUT_VARA_REAL(il_ncfile,
C     $                    il_nc_omd,ila_ncstart,ila_nccount,
C     $                    rla_v)
C
C                      rla_v(1:ila_nlev(iobs))=
C     $                    REAL(dla_dpc(iobs,1:ila_nlev(iobs)))
C                      il_ERR = NF_PUT_VARA_REAL(il_ncfile,
C     $                    il_nc_omd_pc,ila_ncstart,ila_nccount,
C     $                    rla_v)
C
C
                    END DO
C
                    rla_v(:) = rl_missing
C
                    DO iobs = il_scount+1, ip_nobstspmax
                      ila_ncstart(1:4)=(/ib_inst,iobs,1,il_nslot/)
                      ila_nccount(1:4)=(/1,1,ip_nbnivpresmax,1/)
C
                      il_ERR = NF_PUT_VARA_REAL(il_ncfile,
     $                    il_nc_dry_run,ila_ncstart,ila_nccount,
     $                    rla_v)
                    END DO
C
                END IF
C
C** OUTPUT FORECAST VALUES
C
                IF (ll_fct) THEN
                    DO iobs = 1, il_scount
                      ila_ncstart(1:4)=(/ib_inst,iobs,1,il_nslot/)
                      ila_nccount(1:4)=(/1,1,ip_nbnivpresmax,1/)
C
                      rla_v(:) = rl_missing
C
                      lobs=ILOBS(ila_b(ib_inst)-1+iobs)
                      ila_nlev(iobs) = iga_nobslev(lobs)
C
                      rla_v(1:ila_nlev(iobs))=
     $                    REAL(dla_val(iobs,1:ila_nlev(iobs)))
                      il_ERR = NF_PUT_VARA_REAL(il_ncfile,
     $                    il_nc_forecast,ila_ncstart,ila_nccount,
     $                    rla_v)
C
C                      rla_v(1:ila_nlev(iobs))=
C     $                    REAL(dla_diff(iobs,1:ila_nlev(iobs)))
C                      il_ERR = NF_PUT_VARA_REAL(il_ncfile,
C     $                    il_nc_omf,ila_ncstart,ila_nccount,
C     $                    rla_v)
C
C                      rla_v(1:ila_nlev(iobs))=
C     $                    REAL(dla_dpc(iobs,1:ila_nlev(iobs)))
C                      il_ERR = NF_PUT_VARA_REAL(il_ncfile,
C     $                    il_nc_omf_pc,ila_ncstart,ila_nccount,
C     $                    rla_v)
C
                    END DO
C
                    rla_v(:) = rl_missing
C
                    DO iobs = il_scount+1, ip_nobstspmax
                      ila_ncstart(1:4)=(/ib_inst,iobs,1,il_nslot/)
                      ila_nccount(1:4)=(/1,1,ip_nbnivpresmax,1/)
C
                      il_ERR = NF_PUT_VARA_REAL(il_ncfile,
     $                    il_nc_forecast,ila_ncstart,ila_nccount,
     $                    rla_v)
                    END DO
C
                END IF
C
C** OUTPUT ANALYSIS VALUES
C
                IF (ll_ana) THEN
                    DO iobs = 1, il_scount
                      ila_ncstart(1:4)=(/ib_inst,iobs,1,il_nslot/)
                      ila_nccount(1:4)=(/1,1,ip_nbnivpresmax,1/)
C
                      rla_v(:) = rl_missing
C
                      lobs=ILOBS(ila_b(ib_inst)-1+iobs)
                      ila_nlev(iobs) = iga_nobslev(lobs)
C
                      rla_v(1:ila_nlev(iobs))=
     $                    REAL(dla_val(iobs,1:ila_nlev(iobs)))
                      il_ERR = NF_PUT_VARA_REAL(il_ncfile,
     $                    il_nc_analysis,ila_ncstart,ila_nccount,
     $                    rla_v)
C
C                      rla_v(1:ila_nlev(iobs))=
C     $                    REAL(dla_diff(iobs,1:ila_nlev(iobs)))
C                      il_ERR = NF_PUT_VARA_REAL(il_ncfile,
C     $                    il_nc_oma,ila_ncstart,ila_nccount,
C     $                    rla_v)
C
C                      rla_v(1:ila_nlev(iobs))=
C     $                    REAL(dla_dpc(iobs,1:ila_nlev(iobs)))
C                      il_ERR = NF_PUT_VARA_REAL(il_ncfile,
C     $                    il_nc_oma_pc,ila_ncstart,ila_nccount,
C     $                    rla_v)
C
                    END DO
C
                    rla_v(:) = rl_missing
C
                    DO iobs = il_scount+1, ip_nobstspmax
                      ila_ncstart(1:4)=(/ib_inst,iobs,1,il_nslot/)
                      ila_nccount(1:4)=(/1,1,ip_nbnivpresmax,1/)
C
                      il_ERR = NF_PUT_VARA_REAL(il_ncfile,
     $                    il_nc_analysis,ila_ncstart,ila_nccount,
     $                    rla_v)
                    END DO
C
                END IF
C
              END DO
          END IF
C
C** END OF OUTPUT
C
          il_err = NF_CLOSE(il_ncfile)
C
      ENDIF
C
CCC MORE OUTPUT FOR DRY RUN (OmD and OmF) can be true together (1st window)
C
      IF (ll_dry.and.ll_fct) THEN
          ll_fct = .false.
          GO TO 99
      ENDIF
C
CCC 3. FORMATS
C
 101  FORMAT(A68)
 102  FORMAT(I4,I2.2,I2.2,I2.2,I2.2,1X,A6,1X,I5.5,1X,
     +    F6.2,1X,F7.2,1X,I2)
 103  FORMAT(F7.0,1X,I2)
 106  FORMAT(F7.0,1X,F7.0,1X,I2)
 104  FORMAT(A5,1X,E12.5)
 105  FORMAT(A5,1X,E12.5,1X,E12.5,1X,E12.5,1X,F8.2,A1,2X,A1)
C
CCC 4. FLAG CLEANING
C     
      IF (il_tshold .NE. 0) THEN
          iga_tshold = ABS(iga_tshold)
          WHERE(iga_tshold.EQ.2) iga_tshold = 0 
          IF (.NOT.ll_infct) THEN
              DO i=1,icount
                iobs=ILOBS(i)
                iga_tshold(iobs,:,:) = 3
              END DO
          ENDIF
      ENDIF
C
CCC 5. MISFIT OUTPUT
C
C
      IF (ll_infct) THEN
          IF (icount. gt. 0) THEN 
              cl_space = 'vectobs'
              il_time = int(daynum)
              il_usrtag = PL_NO_TAG
              cl_name = 'rda_misfit'
              CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,
     $            rga_misfit,il_err)
          ENDIF
      ENDIF
C
CCC 6. FLUSH UNITS AND AT THE END CLOSE THEM
C
      IF (ip_omd .eq. 1) CALL FLUSH(85)
      IF (ip_omf .eq. 1) CALL FLUSH(86)
      IF (ip_oma .eq. 1) CALL FLUSH(87)
C
      IF (ALL(lla_ncdone)) THEN
          IF (ip_omd .eq. 1) THEN
          WRITE(clf1,
     +    fmt="('HDOMD+',I4.4,I2.2,I2.2,I2.2,'+',I4.4,I2.2,I2.2,I2.2)")
     +    idate0(1),idate0(2),idate0(3),idate0(4),
     +    idate0(1),idate0(2),idate0(3),idate0(4)+ip_assimsize/3600
          CLOSE(85)
          WRITE(*,'(A24,A32)')'++ CLOSING DIAG. FILE : ',clf1
          ENDIF
C
          IF (ip_omf .eq. 1) THEN
          WRITE(clf1,
     +    fmt="('HDOMF+',I4.4,I2.2,I2.2,I2.2,'+',I4.4,I2.2,I2.2,I2.2)")
     +    idate0(1),idate0(2),idate0(3),idate0(4),
     +    idate0(1),idate0(2),idate0(3),idate0(4)+ip_assimsize/3600
          CLOSE(86)
          WRITE(*,'(A24,A32)')'++ CLOSING DIAG. FILE : ',clf1
          ENDIF
C
          IF (ip_oma .eq. 1) THEN
          WRITE(clf1,
     +    fmt="('HDOMA+',I4.4,I2.2,I2.2,I2.2,'+',I4.4,I2.2,I2.2,I2.2)")
     +    idate0(1),idate0(2),idate0(3),idate0(4),
     +    idate0(1),idate0(2),idate0(3),idate0(4)+ip_assimsize/3600
          CLOSE(87)
          WRITE(*,'(A24,A32)')'++ CLOSING DIAG. FILE : ',clf1
          ENDIF
      END IF
C
      RETURN
      END
