CCC
C
      SUBROUTINE MODEL() 
C
CCCCC
C
C   Modele d'integration 
C
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C
C   Centre National de Recherches Meteorologiques
C   Groupe de Modelisation de Grande Echelle et du Climat
C   Equipe de Recherches sur l'Atmosphere Moyenne
C
CCCCC
C
C  Original : S. Massart, 03/2003
C
ccccc
c
      USE palmlib
C
C
      USE PARADI_MOD
      USE ALLOC_MOD
      USE MOCF_MOD
      USE MRAT_MOD
      USE EXPE_MOD
      USE CSTES_MOD
      USE UNDCOLMT_MOD
      USE SRC_MOD
      USE OUTNETCDF_MOD
      USE FORM_MOD
      USE FORMT_MOD
C
      IMPLICIT NONE
C
#ifdef MPI
#include "mpif.h"	
#endif
C
      INTEGER idate0(5), idate00(5)
      REAL daynum
C
C
C       Local declaration
C
      LOGICAL DIAG, LOUT, ll_nooverlap, ll_FIRSTTIME, ll_LASTTIME
      DATA ll_FIRSTTIME/.FALSE./
      SAVE ll_FIRSTTIME
C
      INTEGER NCYCL
      DATA NCYCL/1/
      SAVE NCYCL
C    
      INTEGER NOUT
      INTEGER INICDF
      INTEGER iterassim
      INTEGER ib, ib_lat, ib_lon, ib_niv
      INTEGER :: SELAPS,DELAPS,HELAPS,MELAPS
      INTEGER NSECCY
      INTEGER assimtime
      INTEGER pastassimtime
      LOGICAL ld_out
C
C     MOCAGE
C     
      REAL (KIND=8) :: DAYNUM0,CINTA,CINTB
C
C       PALM
C
      CHARACTER(LEN=PL_LNAME) cl_name, cl_space
      INTEGER il_time, il_usrtag, il_err, il_err2
      INTEGER il_day, il_month, il_year, il_hour, il_min, il_sec
      INTEGER il_tstart, il_tend, il_putstart, il_putend
C
      LOGICAL entered
      SAVE entered
      DATA entered / .TRUE. /
C
C       Ajout de l'increment
C      
      REAL inscoef
      REAL dQQQM1a(ip_lonm1,ip_latm1,ip_nivm1,ip_nassim)
      COMMON/dCONC1a/dQQQM1a
C
C       Variance d'erreur d'ebauche
C
      REAL, DIMENSION(:,:,:,:), ALLOCATABLE :: rda_sigmab
      INTEGER :: il_sigbck
C
c
#ifdef MPI
      CALL MPI_COMM_DUP(PL_COMM_EXEC,MPI_COMM_MOCAGE,IERR)
      CALL MPI_COMM_RANK(MPI_COMM_MOCAGE,MYID,IERR)
      CALL MPI_COMM_SIZE(MPI_COMM_MOCAGE,NPROCS,IERR)
      PRINT *,'======================================================'
      PRINT *,' PROCESSEUR ',MYID+1,' over ',NPROCS,' Rank:', MYID
      PRINT *,'======================================================'
      WRITE(PL_OUT,*)
     $    '======================================================'
      WRITE(PL_OUT,*)
     $    ' PROCESSEUR ',MYID+1,' over ',NPROCS,' Rank:', MYID
      WRITE(PL_OUT,*)
     $    '======================================================'
#else
      NPROCS=1
      MYID=0
#endif
C
      MASTER = 0
ccccc
c     _______________________________________
c    |                                       |
c    | 1. PALM GET INITIALIZED PARAMETERS    |
c    |_______________________________________|
c
ccccc
c
c     1.1. PALM_Get times and date
c
      cl_space = 'one_integer'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'il_tstart'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,il_tstart,il_err)
c
      cl_space = 'one_integer'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'il_tend'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,il_tend,il_err)
c
      cl_space = 'one_integer'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'il_putstart'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,
     $    il_putstart,il_err)
c
      cl_space = 'one_integer'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'il_putend'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,il_putend,il_err)
c
      cl_space = 'one_integer'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'id_iter'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,iterassim,
     $             il_err)
c
      cl_space = 'one_integer'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'id_assimtime'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,assimtime,il_err)
c
      cl_space = 'one_integer'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'id_pastassimtime'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,
     +             pastassimtime,il_err)
c
      cl_space = 'one_real'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'rd_daynum0'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,daynum0,il_err)
C
      cl_space = 'date'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'ida_date0'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,idate0,il_err)
c
      cl_space = 'date'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'ida_date00'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,idate00,il_err)
c
c     1.2. PALM_Get logicals
c
      cl_space = 'one_logical'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'ld_out'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,LOUT,il_err)
c
      cl_space = 'one_integer'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'il_NCDF'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,NCDF,il_err)
C
C*    Activate output for the first time step
C
      INICDF=1
c
      cl_space = 'one_integer'
      il_time = PL_NO_TIME
      il_usrtag = PL_NO_TAG
      cl_name = 'il_NOUT'
      CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,NOUT,il_err)
C
C* Handle the trick to indicate a restart with no overlapping
C
      ll_nooverlap = .FALSE.
      IF (iterassim .lt. 0) THEN
          iterassim = - iterassim
          ll_nooverlap = .TRUE.
      END IF
C
C** MAIN LOOP
C
C* If the dry run has loaded new forcing files, we have to reload the
C* first two
C
      IF ((il_tstart.EQ.0).AND.(il_tstart.EQ.pastassimtime)
     $    .and.(ip_omd.EQ.1)) THEN
          call FORCAGE(-REAL(NSCY),idate0,.FALSE.)
      ENDIF
C
C* Extra time interpolations for the output of the initial condition
C
      IF ((NCDF .gt. 0 .and. INICDF .ne. 0).or.OBS) THEN
C
          NSECCY=mod(il_tstart,NSCY)
          NITER=NSECCY/(NSCY/NITERT)
          CINTB=REAL(NITER)/REAL(NITERT)
          CINTA=1.-CINTB
C          
          IF (IFLAG1) THEN
              XPAM1  = CINTA*XPAM1A  + CINTB*XPAM1B 
              XPHFM1 = CINTA*XPHFM1A + CINTB*XPHFM1B
              TGRIM1 = CINTA*TGRIM1A + CINTB*TGRIM1B 
              UGRIM1 = CINTA*UGRIM1A + CINTB*UGRIM1B 
              VGRIM1 = CINTA*VGRIM1A + CINTB*VGRIM1B 
              WGRIM1 = CINTA*WGRIM1A + CINTB*WGRIM1B 
              PSOLM1 = CINTA*PSOLM1A + CINTB*PSOLM1B
              PVGRIM1 = CINTA*PVGRIM1A + CINTB*PVGRIM1B 
         ENDIF
      ENDIF
C
CCC   WRITE THE INITIAL STATE AT THE BEGINNING OF THE SIMULATION
C        
      IF (NCDF .gt. 0 .and. INICDF .ne. 0
     $    .and. int(daynum0).eq.il_tstart) THEN
          call OUTNETCDF(REAL(il_tstart),idate0,idate00,iterassim)
      ENDIF
C
CCC   WRITE THE INITIAL STATE IN CASE OF A RESTART AFTER AN EMPTY WINDOW
C        
      IF (il_tstart .ne. pastassimtime .and. NCDF .gt. 0 
     $    .and. INICDF .ne. 0 .and. int(daynum0).ne.il_tstart) THEN
          call OUTNETCDF(REAL(il_tstart),idate0,idate00,iterassim)
      ENDIF
C
      IF (OBS .and. myid .eq. master)
     $    CALL MADONA(REAL(il_tstart),idate0,
     $    iterassim,.TRUE.,.FALSE.)

C
C**   MAIN TIME LOOP      
C
      SELAPS = int(real(il_tstart) - daynum0)
      daynum = real(il_tstart) - DT
C
      DO WHILE ((SELAPS+DT) .lt. il_tend)
        daynum = daynum+DT
        SELAPS=int(daynum-daynum0)
        DELAPS=SELAPS/86400
        HELAPS=mod(SELAPS,86400)/3600
        MELAPS=mod(SELAPS,3600)/60
C
#ifdef SBL
#ifdef NIV_60
      NIVBL=49
#else
      NIVBL=41
#endif
      if (MELAPS.EQ.0) then
        if (mod(HELAPS,6).EQ.0) then
          NIVBL=NIVM1
        endif
      endif
#else
      NIVBL=NIVM1
#endif
        WRITE(PL_OUT,'(A14,I1.1,A5,I2.2,A5,I2.2,A21)')
     $      '>> TIMESTEP : ',
     $      DELAPS,' (d) ',
     $      HELAPS,' (h) ',
     $      MELAPS,' (min) FROM BEGINNING'
        CALL flush(PL_OUT)
        WRITE(*,'(A14,I1.1,A5,I2.2,A5,I2.2,A21)') 
     $      '>> TIMESTEP : ',
     $      DELAPS,' (d) ',
     $      HELAPS,' (h) ',
     $      MELAPS,' (min) FROM BEGINNING'
C
C
C* PALM_Get chemistry fields saved at the current time (for a restart)
C*         if the model begin a new assimilation windows
C
C
       IF (int(daynum).EQ.pastassimtime) THEN
c      
           IF (ip_fenetre .NE. ip_correctime) THEN
               cl_space = 'state_tra'
               il_time = int(daynum)
               il_usrtag = 0
               cl_name = 'rda_tra'
               CALL PALM_Query_Get(cl_space,cl_name,il_time,il_usrtag,
     $             il_err)
               IF (il_ERR. eq. 0 ) THEN
                   WRITE(*,'(A50)')
     $          ' > DIR MODEL: Recovering restart QQQM1 from buffer'
                   CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,
     $                 QQQM1,il_err)
               ELSE
                   WRITE(*,'(A48)')
     $          ' > DIR MODEL: Recovering restart QQQM1 from disk'
                   OPEN(66,FILE='buff_on_dsk_qqqm1',FORM='UNFORMATTED')
                   READ(66) QQQM1
                   CLOSE(66)
               ENDIF
c
               IF (NSLS1 .gt. 0) THEN
                   cl_space = 'state_sls'
                   il_time = int(daynum)
                   il_usrtag = 0
                   cl_name = 'rda_sls'
                   CALL PALM_Query_Get(cl_space,cl_name,il_time,
     $                 il_usrtag,il_err)
                   IF (il_ERR. eq. 0 ) THEN
                       WRITE(*,'(A50)')
     $              ' > DIR MODEL: Recovering restart HHHM1 from buffer'
                       CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,
     $                     HHHM1,il_err)
                   ELSE
                       WRITE(*,'(A48)')
     $              ' > DIR MODEL: Recovering restart HHHM1 from disk'
                       OPEN(66,FILE='buff_on_dsk_hhhm1',
     $                     FORM='UNFORMATTED')
                       READ(66) HHHM1
                       CLOSE(66)
                   ENDIF
               ENDIF
           END IF
C
C** Reception of the assimilation increment and its application as
C** model state correction
C
           cl_space = 'controlled_species'
           il_time = int(daynum)
           il_usrtag = PL_NO_TAG
           cl_name = 'rda_dxa'
           CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,
     +         dQQQM1a,il_err)
c
           IF (il_err .EQ. 0) THEN 
               IF (ip_insincr .ne. 1) THEN
                   DO ib = 1, ip_nassim
                     QQQM1(:,:,:,iga_assim_idx(ib)) =
     $                   QQQM1(:,:,:,iga_assim_idx(ib)) +
     $                   dQQQM1a(:,:,:,ib)
                     DO ib_niv=1,ip_nivm1
                       DO ib_lat=1,ip_latm1
                         DO ib_lon=1,ip_lonm1
                           IF (QQQM1(ib_lon,ib_lat,ib_niv,
     $                         iga_assim_idx(ib)).lt.
     $                         REAL(ip_enforced_ana_min)*1.e-9) THEN
                               QQQM1(ib_lon,ib_lat,ib_niv,
     $                             iga_assim_idx(ib))=
     $                             REAL(ip_enforced_ana_min)*1.e-9
                               IF (ip_iprint.gt.0)
     $                            WRITE(PL_OUT,*) '+ Correcting value',
     $                             ' to enforced minimum for point ',
     $                             ib_lon, ib_lat, ib_niv
                           END IF
                         END DO
                       END DO
                     END DO
                   END DO
C
                   IF (NCDF .gt. 0 .and. INICDF .ne. 0) THEN
                       call OUTNETCDF(daynum,idate0,idate00,iterassim)
                   ENDIF
C
                   WRITE(PL_OUT,'(A44,I5)')
     $                 ' > DIR MODEL: Updated control field at time ',
     $                 int(daynum)
                   dQQQM1a = 0.
               ENDIF 
           ELSE
               WRITE(PL_OUT,'(A24,I5)')
     $             "## No correction received at time "
     $             , int(daynum)
               WRITE(PL_OUT,'(A35)')
     $             "## It could be due to a lack of obs"
           END IF
c
       ENDIF
C
C     Send PALM files at the first time of the window (i.c.) if required
C        
        IF (int(daynum).eq.il_putstart.and.
     $      il_tstart .eq. il_putstart.and.
     $      myid.eq.master) THEN
C
            ALLOCATE( rda_sigmab(ip_lonm1,ip_latm1,ip_nivm1,ip_nassim))
C        
            DO ib = 1, ip_nassim
              rda_sigmab(:,:,:,ib) =
     $            QQQM1(:,:,:,iga_assim_idx(ib))
            END DO

C
            IF (ip_iprint .EQ. 1) THEN
                WRITE(*,*) 'Sending model state for ',int(daynum)
                WRITE(PL_OUT,*) 'Sending model state for ',int(daynum)
                CALL FLUSH(PL_OUT)
            END IF
            cl_space = 'controlled_species'
            il_time = int(daynum)
            il_usrtag = PL_NO_TAG
            cl_name = 'rda_x'
            CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,
     +          rda_sigmab,il_err)
C
            DEALLOCATE (rda_sigmab)
C
            cl_space = 'ground'
            il_time = int(daynum)
            il_usrtag = PL_NO_TAG
            cl_name = 'rda_psolm1'
            CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,PSOLM1,
     $          il_err)
C
C* For the current observation operator, the physical fields are
C* unnecessary. Their communications are toggled off
C
C        cl_space = 'grim1'
C        il_time = int(daynum)
C        il_usrtag = PL_NO_TAG
C        cl_name = 'rda_tgrim1'
C        CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,TGRIM1,il_err)
C
C        cl_space = 'grim1'
C        il_time = int(daynum)
C        il_usrtag = PL_NO_TAG
C        cl_name = 'rda_ugrim1'
C        CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,UGRIM1,il_err)
C
C        cl_space = 'grim1'
C        il_time = int(daynum)
C        il_usrtag = PL_NO_TAG
C        cl_name = 'rda_vgrim1'
C        CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,VGRIM1,il_err)
C      
        ENDIF 
C       
C*
C
      IF(
     $    ((int(daynum) .EQ. int(daynum0) + ip_assimsize) .AND.
     $        (ip_correctime .NE. ip_fenetre) .AND. ll_nooverlap) 
     $    .OR.
     $    (ip_correctime .EQ. ip_fenetre .AND.
     $          int(daynum) .EQ. int(daynum0) + ip_assimsize)
     $    ) THEN
          ll_nooverlap = .false.
          WRITE(PL_OUT,"('>> Saving restart field at ',I5)") int(daynum)
          WRITE(PL_OUT,"('>> And SHUTTING DOWN THE SIMULATION')")
          WRITE(*,"('>> Saving restart field at ',I5)") int(daynum)
          WRITE(*,"('>> And SHUTTING DOWN THE SIMULATION')")
          CALL outhisto(daynum,idate0,-1)
          IF (NCDF .gt. 0)
     $        CALL outnetcdf(daynum,idate0,idate00,iterassim)
          CALL PALM_Abort(il_err)
      END IF
C
CAP January 6th 2007
CAP Interesting enough!! What's the hell is that ?
CAP Maybe a residuate of the linear correction ?
CAP To discuss with SM
C          
      IF ((int(daynum).GE.pastassimtime) .AND.
     +     (int(daynum).LT.assimtime)) THEN
        inscoef = 2 * (daynum - pastassimtime + 900) * 900
     +              / (ip_fenetre * (ip_fenetre + 900))
        DO ib = 1, ip_nassim
          QQQM1(:,:,:,iga_assim_idx(ib)) =
     $        QQQM1(:,:,:,iga_assim_idx(ib)) +
     $        inscoef * dQQQM1a(:,:,:,ib)
        END DO
      ENDIF
C
C** Saving the restart (N.B. the BUFFER vs disk choice)
C
      IF (myid.eq.master .and. int(daynum).EQ.assimtime) THEN
c      
       IF (ip_fenetre .NE. ip_correctime) THEN
        cl_space = 'state_tra'
        il_time = assimtime
        il_usrtag = 0
        cl_name = 'rda_tra'
        CALL PALM_Query_Put(cl_space,cl_name,il_time,il_usrtag,il_err)
        IF (il_ERR. eq. 0 ) THEN
            WRITE (*,'(A33)') ' > Saving restart QQQM1 in buffer'
            CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,QQQM1,
     $          il_err)
        ELSE
            WRITE (*,'(A31)') ' > Saving restart QQQM1 on disk'
            OPEN(66,FILE='buff_on_dsk_qqqm1',FORM='UNFORMATTED')
            WRITE(66) QQQM1
            CLOSE(66)
        ENDIF
c
        IF (NSLS1 .gt. 0) THEN
            cl_space = 'state_sls'
            il_time = assimtime
            il_usrtag = 0
            cl_name = 'rda_sls'
            CALL PALM_Query_Put(cl_space,cl_name,il_time,il_usrtag,
     $          il_err)
            IF (il_ERR. eq. 0 ) THEN
                WRITE (*,'(A33)') ' > Saving restart HHHM1 in buffer'
                CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,HHHM1,
     $          il_err)
            ELSE
            WRITE (*,'(A31)') ' > Saving restart HHHM1 on disk'
                OPEN(66,FILE='buff_on_dsk_hhhm1',FORM='UNFORMATTED')
                WRITE(66) HHHM1
                CLOSE(66)
            ENDIF
        ENDIF
c      
      ELSE
C
CAP January 6th 2007
CAP What's the hell is that too ?
CAP Maybe a residuate of the non overlapping restart ?
CAP To study better
CAP
        dQQQM1a = 0.
C      
        cl_space = 'controlled_species'
        il_time = assimtime
        il_usrtag = PL_NO_TAG
        cl_name = 'rda_dxa'
        CALL PALM_Query_Put(cl_space,cl_name,il_time,il_usrtag,il_err)
        IF (il_ERR. eq. 0 ) CALL PALM_Put(cl_space,cl_name,il_time,
     +               il_usrtag,dQQQM1a,il_err)
C     
      END IF
CAPC
CAPC** Send the background error variance estimate
CAPC
CAP      ALLOCATE( rda_sigmab(ip_lonm1,ip_latm1,ip_nivm1,ip_nassim))
CAPC     
CAP        cl_space = 'one_integer'
CAP        il_time = assimtime 
CAP        il_usrtag = PL_NO_TAG
CAP        cl_name = 'il_sigmab'
CAP        CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,
CAP     +               il_sigbck,il_err)
CAPC        
CAP        WRITE(*,'(A2)') '++'
CAP        WRITE(*,'(A24,A14)') '++ COMPUTING BACKGROUND ',
CAP     $      'ERROR VARIANCE'
CAP        WRITE(*,'(A26,I3,A1)') 
CAP     $      ' + USING A % STD. ERR. OF ', il_sigbck,'%'
CAP        WRITE(*,'(A2)') '++'
CAP        WRITE(PL_OUT,'(A24,A14)') '++ COMPUTING BACKGROUND ',
CAP     $      'ERROR VARIANCE'
CAP        WRITE(PL_OUT,'(A26,I3,A1)') 
CAP     $      ' + USING A % STD. ERR. OF ', il_sigbck,'%'
CAPC
CAP       DO ib = 1, ip_nassim
CAP         rda_sigmab(:,:,:,ib) =
CAP     $       QQQM1(:,:,:,iga_assim_idx(ib)) * REAL(il_sigbck)/100.
CAP       END DO
CAPC     
CAP       cl_space = 'controlled_species'
CAP       il_time = assimtime
CAP       il_usrtag = PL_NO_TAG
CAP       cl_name = 'rda_sigmab'
CAP       CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,
CAP     +     rda_sigmab,il_err) 
CAPC
CAP       DEALLOCATE( rda_sigmab )
C
      ENDIF
