#!/bin/ksh
#
echo
echo '==========================='
echo '>>> Script compil_mocage.sh'
echo '==========================='
#
################################################################################
#
#   --- Compilation ---
#
#   Autor : E. Le Flochmoen, Laboratoire d'Aerologie, 04/2007
#
#   Modification : 
#
################################################################################

echo "Directory from where the compiled MOCAGE has to be recovered : $DIRSOURCES/"
if [ ! -d $DIRSOURCES ] ; then
 echo "The directory $DIRSOURCES doesn't exist"
cat > $PATH_WORK/tescontinue << EOL
STOP
EOL
 exit
fi

if [ $COMPIL = 1 ] ; then

 cd $DIRSOURCES
 if [ ! -h mocage.F ] ; then
  ./inst_links	     
 fi
 rm -f Make.commands
 if [ $STATION = tori ] ; then
  ln -s Make.commands.nec.omp Make.commands
  make
 fi
 if [ $STATION = aerosv1 ] ; then
  ln -s Make.commands.LA Make.commands
  make
 fi
 if [ $STATION = CERFACS ] ; then
     if [ $HOST = stratus.cerfacs.fr ] ; then
	 ln -s Make.commands.stratus Make.commands
     else
	 ln -s Make.commands.pclinux Make.commands
     fi
  make
 fi

 FLAG=$?
 cd $PATH_WORK
 if [ $FLAG == 0 ] ; then
cat > tescontinue << EOL
GOON
EOL
 else
cat > tescontinue << EOL
STOP
EOL
  echo "FATALE-5 job MOCAGE : Error during the copilation of MOCAGE !"
#  if [ $STATION = tori ] ; then
#    ja
#  fi
 fi

else

 cd $PATH_WORK
cat > tescontinue << EOL
GOON
EOL

fi

