#!/bin/ksh
#
#===============================#
# Give the domain configuration #
#===============================#
#
echo
echo '===================='
echo '>>> Script getdom.sh'
echo '===================='
#
# NORMAL
#
DOM1=GLOB22
dom1=glob22
NLON1=180
NLAT1=90
FORM1=arpege
DOM2=EURO11
dom2=euro11
NLON2=60
NLAT2=30
FORM2=arpege
DOM3=FRA025
dom3=fra025
NLON3=72
NLAT3=56
FORM3=arpege
DOM4=RSE008
dom4=rse008
NLON4=48
NLAT4=48
FORM4=aladin
#
# CLIMAT T42
#
if [ $MOCFG = T42 ] ; then
DOM1=GLOT42
dom1=glot42
NLON1=128
NLAT1=64
FORM1=ECMWF
DOM2=EURAT5
dom2=eurat5
NLON2=148
NLAT2=104
FORM2=arpege
DOM3=FRA025
dom3=fra025
NLON3=72
NLAT3=56
FORM3=arpege
DOM4=RSE008
dom4=rse008
NLON4=48
NLAT4=48
FORM4=aladin
fi
#
# CLIMAT T21
#
if [ $MOCFG = T21 ] ; then
DOM1=GLOT21
dom1=glot21
NLON1=64
NLAT1=32
FORM1=ECMWF
DOM2=EURAT5
dom2=eurat5
NLON2=148
NLAT2=104
FORM2=arpege
DOM3=FRA025
dom3=fra025
NLON3=72
NLAT3=56
FORM3=arpege
DOM4=RSE008
dom4=rse008
NLON4=48
NLAT4=48
FORM4=aladin
fi
#
# ACCIDENT
#
if [ $MOCFG = ACDT ] ; then
DOM1=GLOB22
dom1=glob22
NLON1=180
NLAT1=90
FORM1=arpege
DOM2=EURAT5
dom2=eurat5
NLON2=148
NLAT2=104
FORM2=arpege
DOM3=FRA025
dom3=fra025
NLON3=72
NLAT3=56
FORM3=arpege
DOM4=RSE008
dom4=rse008
NLON4=48
NLAT4=48
FORM4=aladin
fi
#
# FORECAST
#
if [ $MOCFG = PREV ] ; then
DOM1=GLOB33
dom1=glob33
NLON1=120
NLAT1=60
FORM1=arpege
DOM2=EMEP05
dom2=emep05
NLON2=80
NLAT2=56
FORM2=arpege
DOM3=FRAN01
dom3=fran01
NLON3=150
NLAT3=110
FORM3=aladin
DOM4=DUMMY0
dom4=dummy0
NLON4=1
NLAT4=1
FORM4=none
fi
#
# FORECAST BIS
#
if [ $MOCFG = PRV2 ] ; then
DOM1=GLOB44
dom1=glob44
NLON1=90
NLAT1=45
FORM1=arpege
DOM2=EMEP05
dom2=emep05
NLON2=80
NLAT2=56
FORM2=arpege
DOM3=FRAN01
dom3=fran01
NLON3=150
NLAT3=110
FORM3=aladin
DOM4=DUMMY0
dom4=dummy0
NLON4=1
NLAT4=1
FORM4=none
fi
#
# AMMA
#
if [ $MOCFG = AMMA ] ; then
DOM1=GLOB22
dom1=glob22
NLON1=180
NLAT1=90
FORM1=arpege
DOM2=AMMA05
dom2=amma05
NLON2=144
NLAT2=160
FORM2=arpege
DOM3=DUMMY0
dom3=dummy0
NLON3=1
NLAT3=1
FORM3=none
DOM4=DUMMY0
dom4=dummy0
NLON4=1
NLAT4=1
FORM4=none
fi
#
if [ $MOCFG = AC2T ] ; then
DOM1=GLOB05
dom1=glob05
NLON1=720
NLAT1=360
FORM1=arpege
DOM2=DUMMY01
dom2=dummy01
NLON2=1
NLAT2=1
FORM2=arpege
DOM3=DUMMY0
dom3=dummy0
NLON3=1
NLAT3=1
FORM3=none
DOM4=DUMMY0
dom4=dummy0
NLON4=1
NLAT4=1
FORM4=none
fi


#
if [ $NDOM -eq 1 ] ; then
	LISTDOM="$DOM1"
elif [ $NDOM -eq 2 ] ; then
	LISTDOM="$DOM1 $DOM2"
elif [ $NDOM -eq 3 ] ; then
	LISTDOM="$DOM1 $DOM2 $DOM3"
elif [ $NDOM -eq 4 ] ; then
	LISTDOM="$DOM1 $DOM2 $DOM3 $DOM4"
fi
export DOM1 DOM2 DOM3 DOM4 LISTDOM
export dom1 dom2 dom3 dom4
export FORM1 FORM2 FORM3 FORM4
#
cd $PATH_WORK
cat > listedom << EOF
$LISTDOM
EOF
cat > namedom << EOF
$DOM1 $DOM2 $DOM3 $DOM4
EOF
echo '>> NO CHECK FOR CONSISTENCY OF NAMELIST YET!'
