#!/bin/ksh
#
#=================================#
# Prepare automatic job splitting #
#=================================#
#
echo
echo '======================='
echo '>>> Script getsubjob.sh'
echo '======================='
#
NJOB=0
#
cp outdates_subjob outdates
set -A DATES `cat outdates`
rm -r outdates
#
DATESp1=`expr ${#DATES[*]} + 1`
NTOTJOB=`expr $DATESp1 / 2`
export NJOB DATES NTOTJOB

if [ ${#DATES[*]} -ne 2 ] ; then
#
echo '>> ORIGINAL JOB IS TOO LONG : SPLITTING IN PROGRESS'
NJOB=1
#JOBDATE=`date '+%m%d%H%M%S'`
JOBDATE=`date '+%d-%m-%y:%Hh%Mm%Ss'`
DIRSPLIT=$PATH_JOBS/TMPSPLIT_${JOBDATE}
NAMREQ=${PBS_JOBNAME}
#
if test ! -d $DIRSPLIT ; then
mkdir $DIRSPLIT
fi
#
n=0
nf=1
#
cp -p ${PATH_JOBS}/$JOBNAME TEMPO
#
np1=`expr $n + 1`
nfp1=`expr $nf + 1`
#
### Job 1 ###
#
cat - << EOF | ed -s TEMPO > /dev/null
/set/
. a
banner ${NAMREQ}${nf}/${NTOTJOB}
.
/DATEIN=/
. d
-1 a
DATEIN=${DATES[$n]}
.
/DATEOUT=/
. d
-1 a
DATEOUT=${DATES[$np1]}
.
$
. a
#####
#
echo
echo '##########'
echo
echo '>> SUBMITTING NEXT SUB-JOB : '$nfp1' / '$NTOTJOB
#
cd $DIRSPLIT
if [ $STATION = tori ] ; then
$MTOOL_ROOT/bin/mtool_jobfilter.pl $JOBNAME$nfp1
else
./$JOBNAME$nfp1
fi
echo
echo 'SUBMITTING '$DIRSPLIT/$JOBNAME$nfp1
#
#####
#
.
w TEMPO
q
EOF
#
echo '>> SUB-JOB '$nf' / '$NTOTJOB' HAS BEEN PREPARED : '${DATES[$n]}' TO '${DATES[$np1]}
n=`expr $n + 2`
cp -p TEMPO $DIRSPLIT/$JOBNAME$nf
nf=`expr $nf + 1`
#
while test $n -le ${#DATES[*]}-4
do
#
cp -p ${PATH_JOBS}/$JOBNAME TEMPO
np1=`expr $n + 1`
nfp1=`expr $nf + 1`
#
### Job N ###
#
cat - << EOF | ed -s TEMPO > /dev/null
/set/
. a
banner ${NAMREQ}${nf}/${NTOTJOB}
.
/DATEIN=/
. d
-1 a
DATEIN=${DATES[$n]}
.
/DATEOUT=/
. d
-1 a
DATEOUT=${DATES[$np1]}
.
/NSTART=/
. d
-1 a
NSTART=1
.
$
. a
#####
#
echo
echo '##########'
echo
echo '>> SUBMITTING NEXT SUB-JOB : '$nfp1' / '$NTOTJOB
#
cd $DIRSPLIT
if [ $STATION = tori ] ; then
$MTOOL_ROOT/bin/mtool_jobfilter.pl $JOBNAME$nfp1
else
./$JOBNAME$nfp1
fi
echo
echo 'SUBMITTING '$DIRSPLIT/$JOBNAME$nfp1
#
#####
#
.
w TEMPO
q
EOF
#
echo '>> SUB-JOB '$nf' / '$NTOTJOB' HAS BEEN PREPARED : '${DATES[$n]}' TO '${DATES[$np1]}
n=`expr $n + 2`
cp -p TEMPO $DIRSPLIT/$JOBNAME$nf
nf=`expr $nf + 1`
done
#
### Last job ###
#
if [ $n -eq  ${#DATES[*]}-2 ] ;then
cp -p ${PATH_JOBS}/$JOBNAME TEMPO
np1=`expr $n + 1`
cat - << EOF | ed -s TEMPO > /dev/null
/set/
. a
banner ${NAMREQ}${nf}/${NTOTJOB}
.
/DATEIN=/
. d
-1 a
DATEIN=${DATES[$n]}
.
/DATEOUT=/
. d
-1 a
DATEOUT=${DATES[$np1]}
.
/NSTART=/
. d
-1 a
NSTART=1
.
$
. a
#####
#
echo
echo '##########'
echo
echo '>> END OF LAST SUB-JOB!'
#
#
#cat > .jobCLEAN$JOBDATE << EON
#cp -p $DIRSPLIT/${JOBNAME}*.o* ${PBS_O_WORKDIR}/.
#rm -rf $DIRSPLIT
#EON
#$MTOOL_ROOT/bin/mtool_jobfilter.pl .jobCLEAN$JOBDATE
#echo 'SUBMITTING '.jobCLEAN$JOBDATE
#
#####
#
.
w TEMPO
q
EOF
#
###
#
echo '>> SUB-JOB '$nf' / '$NTOTJOB' HAS BEEN PREPARED : '${DATES[$n]}' TO '${DATES[$np1]}
cp -p TEMPO $DIRSPLIT/$JOBNAME$nf
fi
#
echo '>> END OF ORIGINAL JOB'
echo '>> SUBMITTING SUB-JOB : 1 / '$NTOTJOB
#
cat > $PATH_WORK/dirsplit << EOL
${DIRSPLIT}
EOL
exit
#
else
 echo '>> NO SPLITTING'
 if [[ -a $PATH_WORK/dirsplit ]] ; then
  rm $PATH_WORK/dirsplit
 fi
fi

